开发人员手册

Develop DHIS core version master

DHIS2 Documentation Team

Copyright © 2008-2023 DHIS2 Team

source.revision.date: 2026-04-01

Warranty: THIS DOCUMENT IS PROVIDED BY THE AUTHORS ‘’AS IS’’ AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS MANUAL AND PRODUCTS MENTIONED HEREIN, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

License: Permission is granted to copy, distribute and/or modify this document under the terms of the GNU Free Documentation License, Version 1.3 or any later version published by the Free Software Foundation; with no Invariant Sections, no Front-Cover Texts, and no Back-Cover Texts. A copy of the license is included in the source of this documentation, and is available here online: http://www.gnu.org/licenses/fdl.html

toc.title

总览

Web API 是一个组件,它使外部系统成为可能 访问和操作存储在 DHIS2 实例中的数据。更多的 准确地说,它为广泛的 为第三方等应用项目公开数据和服务方法 软件客户端、门户网站和内部 DHIS2 模块。

介绍

Web API 遵循 REST 架构风格背后的许多原则。以下是一些重要原则:

  1. 基本构建块称为*资源*。 资源可以是任何暴露在 Web 上的东西,从文档到 业务流程 - 客户端可能想要与之交互的任何内容。 资源的信息方面可以通过资源*表示*进行检索或交换。 表示是资源在任何特定时间的状态视图。例如,DHIS2 中的*可视化* 资源代表了汇总数据的*可视化*,可用于 一组特定的参数。该资源可以以 各种表示格式获取,包括 JSON 和 CSV。 所有资源都可以通过 URI(也称为
  2. URL)唯一标识。所有资源都有一个默认表示。您可以 称为 URL)。所有资源都有一个默认表示法。您可以 查询参数来表明您对特定表示的兴趣。因此,要检索 CSV 格式的 提供*Accept* HTTP 标头、文件扩展名或*format*格式 或在请求 URL 中添加 .csv 或 ?format=csv。 与 API 的交互需要正确使用 HTTP 方法 或 动词。这意味着对于资源,您必须在想要检索它时发出 GET
  3. 请求,在想要创建它时发出 POST 请求, 在想要更新它时发出 PUT 请求,在想要删除它时发出 DELETE 请求。 请求,当您要检索它时,POST 请求 创建一个,要更新时*PUT*,要删除时*DELETE*。 基本身份验证

个人访问令牌 (PAT)

OAuth 2

  • 验证并获取当前已认证用户的信息。
  • GET /api/me
  • 获取当前已通过身份验证用户的授权列表。

    GET /api/me/authorization

检查当前已通过身份验证的用户是否拥有指定权限。

GET /api/me/authorization/{authority}

例如,检查用户是否拥有 F_CONSTANT_ADD 权限。

GET /api/me/authorization/F_CONSTANT_ADD

响应将以 JSON 格式显示为true或 false。

基本认证 { #webapi_basic_authentication }

DHIS2 Web API 支持*基本身份验证*。基本身份验证 是一种客户端通过 HTTP 将登录凭据发送到 Web 服务器的技术。从技术上讲,用户名后附有冒号和 密码,经过 Base64 编码,前缀 Basic 并作为值提供给 Authorization HTTP 标头。更正式的格式是:

Authorization: Basic base64encode(username:password)

大多数网络开发环境都支持基本

身份验证,例如 Apache HttpClient 和 Spring RestTemplate。 一个重要的注意事项是此身份验证方案不提供安全性, 因为用户名和密码是以纯文本形式发送的,可以很容易地 被攻击者截获。仅当服务器 使用 SSL/TLS (HTTPS) 加密与客户端的通信时才应使用。请将此 视为与 Web API 进行安全交互的硬性要求。

两因素验证 { #webapi_2fa }

DHIS2 支持两因素身份验证。这可以为每个用户启用。 启用后,用户将被要求在登录时输入 2FA 代码。您 可以在此处阅读更多关于 2FA 的信息。

个人访问令牌{ #webapi_pat_authentication }

个人访问令牌 (PAT) 是使用 API 时对 DHIS2 进行身份验证的密码替代方法。

个人访问令牌(PAT)是使用 API 时对 DHIS2 进行身份验证的另一种方式。

PAT 可作为 HTTP 基本身份验证的一种更安全的替代方式。 在创建新应用或脚本等时,PAT 应该是您的首选。

HTTP 基本身份验证被认为是不安全的,原因包括

它会以明文发送用户名和密码。在 未来的 DHIS2 版本中,基本身份验证可能会被弃用或改为选择启用,这意味着需要在配置中明确启用基本身份验证。 重要的安全问题! { #important-security-concerns }

您的 PAT 将自动继承用户拥有的所有权限和授权。 因此,根据您打算使用令牌的方式,限制授予令牌的访问权限极为重要。 请参阅 配置您的令牌 部分。

如果您只想让令牌访问服务器的某一特定部分,建议您创建一个新的专用用户,并只分配您希望它访问的角色/权限。 如果您只想让令牌访问服务器的一个狭窄且特定的部分,建议您创建一个新的专用用户,并只分配您希望它访问的角色/权限。

创建令牌

要创建新的 PAT,您有两个选择:

A. 在账户个人资料页面的用户界面上创建令牌。

B. 通过 API 创建令牌。

A. 在账户页面上创建令牌 { #a-creating-a-token-on-the-account-page } * 使用用户名和密码登录,进入个人资料页面 (点击右上角,从下拉菜单中选择 "编辑个人资料")。 在用户配置文件页面,从左侧菜单中选择 "个人访问令牌"。 现在您应该在 "管理个人访问令牌" 页面上看到 文本:"您没有任何有效的个人访问令牌"。 点击 "生成新令牌" 创建新令牌。 弹出 "生成新令牌" 窗口,为您提供两种选择: * 1. 服务器/脚本上下文 { #1-serverscript-context }

"该类型用于不会被浏览器访问的集成和脚本"。

如果您计划在应用、脚本或类似文件中使用令牌,则应选择此类型。

2. 浏览器上下文

"这种类型适用于将通过 Web 浏览器访问的应用,如公共门户网站"。

如果您需要在网页上链接到 DHIS2,或嵌入 iframe, 这可能就是您需要的令牌类型。

配置令牌

选择需要的令牌类型后,可以为令牌配置不同的访问限制。 所谓限制,是指如何限制和缩小令牌的使用范围。 如果计划在公共环境中使用令牌,这一点至关重要, 例如,在其他网站的公共仪表板上嵌入 iframe。 由于令牌总是拥有与用户相同的访问权限/授权,因此如果您打算在公共环境中使用令牌,或者在任何您无法 100% 控制的环境中使用它,就需要特别小心。

注意:如果其他人获取了您的令牌,他们可以执行您的用户可以执行的任何操作。 无法区分使用令牌执行的操作和用户执行的其他操作。

重要:如果您打算在非安全和/或公共环境中使用 PAT 令牌,强烈建议您创建一个单独的专用用户,该用户只能拥有您希望令牌拥有的角色/权限,

例如,在您无法 100% 控制的 PC 或服务器上,或 "嵌入" 到另一台服务器的网页中。

限制类型 { #constraint-types }

到期时间

允许的 IP 地址

允许的 HTTP 方法

  • 允许的 HTTP 引用来源
  • 有效期 { #expiry-time }
  • 到期时间用于设置令牌的有效期,默认为 30 天。过期后,令牌将直接返回 401(未授权)响应。 您可以设置任何到期时间,但我们强烈建议您根据自己的使用情况设置一个合理的过期时间。
  • IP 地址 { #ip-addresses }
这是一个以逗号分隔的 IP 地址列表,用于限制令牌请求的来源。

重要:IP 地址验证依赖于 X-Forwarded-For 标头,该标头可能被伪造。 为了安全起见,请确保负载平衡器或反向代理会覆盖该标头。

HTTP 方法

以逗号分隔的 HTTP 方法列表,您希望令牌能够使用这些方法。 如果您只需要令牌来查看数据,而不是修改或删除数据,那么只选择 GET HTTP 方法 是合理的。

HTTP 引用来源 { #http-referrers }

HTTP 引用来源是添加到请求中的一个标头,当您点击链接时,它会显示您点击链接时所在的网站/页面。

点击此处了解有关 HTTP 引用来源头的更多信息: https://en.wikipedia.org/wiki/HTTP_referer

这可用于限制使用嵌入到其他网站页面上的 "公共" 令牌。 确保引用来源标头与网站主机名相匹配,有助于避免令牌被滥用, 例如,如果有人在公共论坛上发布令牌。

重要:这不是一项安全功能。Referer 标头很容易被欺骗。

此设置旨在阻止未经授权的第三方开发人员连接 到公共访问实例。

保存令牌 { #saving-a-token }

完成令牌配置后,点击弹出窗口右下方的 "生成新令牌" 按钮保存。 这样,令牌将被保存,并在服务器上生成一个秘密令牌密钥。 新的密钥将显示在 PAT 令牌列表底部,背景为绿色 和文本 "新创建的令牌"。 秘密令牌密钥的外观与此类似:

d2pat_5xVA12xyUbWNedQxy4ohH77WlxRGVvZZ1151814092

重要:生成的秘密令牌密钥只会显示一次,因此请务必

现在就复制令牌密钥,并将其保存在安全的地方,以便以后使用。 秘密令牌密钥将在服务器上安全散列,只有该秘密令牌密钥的散列才会保存到数据库中。 这样做的目的是在有人未经授权访问数据库时,最大限度地减少安全影响。 这与处理密码的方式类似。

使用应用项目接口{ #creating-a-token-with-the-api } 创建令牌 示例说明如何使用 API 创建新的个人访问令牌:

POST /api/apiToken
Content-Type: application/json
Authorization: Basic admin

{}

注意:记住请求体中的空 JSON 主体 ({})!

这将返回一个包含类似令牌的响应:

{
  "httpStatus": "已创建",
  "httpStatusCode": 201,
  "status": "正常",
  "response": {
     "responseType": "ApiTokenCreationResponse",
     "key": "d2pat_5xVA12xyUbWNedQxy4ohH77WlxRGVvZZ1151814092",
     "uid": "jJYrtIVP7qU",
     "klass": "org.hisp.dhis.security.apikey.ApiToken",
     "errorReports": []
  }
}
注意:令牌密钥只会在此响应中显示一次。 您需要将其复制并保存在安全的地方,以便以后使用!

令牌本身由三部分组成:

前缀: (d2pat_) 表示这是什么类型的令牌。

随机字节 Base64 编码: (5xVA12xyUbWNedQxy4ohH77WlxRGVvZZ)

CRC32 校验和:(1151814092) 校验和部分以 0 填充,因此长度始终为 10 个字符。 1. 使用 API { #configure-token-with-the-api } 配置令牌 2. 要更改令牌上的任何限制条件,可发出以下 HTTP API 请求。 3. 注意:创建令牌后,只能修改约束条件。

```bash

PUT /api/apiToken/jJYrtIVP7qU Content-Type: application/json Authorization: Basic admin

```json
{
  "version": 1,
  "type": "PERSONAL_ACCESS_TOKEN",
  "expires": 163465349603200,
  "attributes": [
      {
        "type": "IpAllowedList",
        "allowedIps": ["192.168.0.1"]
      },
      {
        "type": "MethodAllowedList",
        "allowedMethods": ["GET"]
      }
  ]
}

使用个人访问令牌 { #using-a-personal-access-token }

要使用新创建的令牌发出请求,请使用相应的授权标头 。授权标头格式如下:

Authorization: ApiToken [YOUR_SECRET_API_TOKEN_KEY]

例如:

GET /api/apiToken/jJYrtIVP7qU
Content-Type: application/json
Authorization: ApiToken d2pat_5xVA12xyUbWNedQxy4ohH77WlxRGVvZZ1151814092

删除个人访问令牌{ #deleting-a-personal-access-token }

您可以在创建 PAT 的个人资料页面的用户界面中删除 PAT、 或像这样通过应用项目接口删除:

DELETE /api/apiToken/jJYrtIVP7qU
Content-Type: 应用项目/json
授权:ApiToken d2pat_5xVA12xyUbWNedQxy4ohH77WlxRGVvZZ1151814092

OAuth2

DHIS2支持* OAuth2 身份验证协议。OAuth2是开放的 授权标准,允许第三方客户端代表DHIS2用户进行连接,并为对Web API的后续请求获取*bearer token。DHIS2不支持细粒度 OAuth2角色,而是根据用户角色提供应用访问权限,基于 DHIS2用户的身份。

您要允许其使用OAuth 2身份验证的每个客户端都必须 在DHIS2中注册。要添加新的OAuth2客户端,请转到应用>设置> OAuth2客户端。 在用户界面中,单击*添加新*,然后输入所需的客户端名称和授权类型。

创建客户端

可以通过Web API添加OAuth2客户端。例如,我们可以 发送这样的有效载荷:

{
  "name": "OAuth2 Demo Client",
  "cid": "demo",
  "secret": "1e6db50c-0fee-11e5-98d0-3c15c2c6caf6",
  "grantTypes": [
    "password",
    "refresh_token",
    "authorization_code"
  ],
  "redirectUris": [
    "http://www.example.org"
  ]
}

可用以下命令发送有效负载:

SERVER="https://play.dhis2.org/dev"
curl -X POST -H "Content-Type: application/json" -d @client.json
  -u admin:district "$SERVER/api/oAuth2Clients"

该客户端将作为下一个授权类型示例的基础。

授权类型:密码 { #webapi_oauth2_password }

所有授权类型中最简单的是*password*授权类型。这 种授权类型类似于基本身份验证,因为它 要求客户端收集用户的用户名和密码。作为 示例,我们可以使用我们的演示服务器:

SERVER="https://play.dhis2.org/dev"
SECRET="1e6db50c-0fee-11e5-98d0-3c15c2c6caf6"

curl -X POST -H "Accept: application/json" -u demo:$SECRET "$SERVER/uaa/oauth/token"
  -d grant_type=password -d username=admin -d password=district

这将给您类似的响应:

{
  "expires_in": 43175,
  "scope": "ALL",
  "access_token": "07fc551c-806c-41a4-9a8c-10658bd15435",
  "refresh_token": "a4e4de45-4743-481d-9345-2cfe34732fcc",
  "token_type": "bearer"
}

现在,我们将专注于access_token,这就是我们 将用作身份验证(承载)令牌的内容。例如,我们将获取 使用我们的令牌访问所有数据元素:

SERVER="https://play.dhis2.org/dev"
curl -H "Authorization: Bearer 07fc551c-806c-41a4-9a8c-10658bd15435" "$SERVER/api/33/dataElements.json"

授权类型:refresh_token { #webapi_refresh_token }

通常,访问令牌的有效性有限。您可以查看 上一个示例中响应的expires_in属性, 了解令牌何时到期。要获得新的access_token,您 可以再次访问服务器并使用refresh_token, 这允许您获得更新的令牌而无需要求 再次使用用户凭据。

SERVER="https://play.dhis2.org/dev"
SECRET="1e6db50c-0fee-11e5-98d0-3c15c2c6caf6"
REFRESH_TOKEN="a4e4de45-4743-481d-9345-2cfe34732fcc"

curl -X POST -H "Accept: application/json" -u demo:$SECRET "$SERVER/uaa/oauth/token"
  -d "grant_type=refresh_token" -d "refresh_token=$REFRESH_TOKEN"

响应与获得令牌开始时的响应完全相同。

授权类型:authorization_code { #webapi_authorization_code }

如果您不想在外部存储用户凭据,建议使用授权码授权类型。 它允许DHIS2直接从用户收集用户名/密码,而不是由客户端 收集,然后代表用户进行身份验证。请注 意这种方法使用了客户端有效载荷中的redirectUris部分。

第 1 步:使用 Web 浏览器访问以下 URL。如果您有多个 重定向 URI,可能需要添加 &redirect_uri=http://www.example.org 到 URL:

```bash

SERVER="https://play.dhis2.org/dev" $SERVER/uaa/oauth/authorize?client_id=demo&response_type=code

第 2 步:在用户成功登录并接受您的
客户端访问后,它将重定向回您的重定向 URI,如下所示:

    http://www.example.org/?code=XYZ

第 3 步:这一步类似于我们在密码授权类型中所做的,
使用获得的代码,我们现在将请求访问令牌:

```bash
SERVER="https://play.dhis2.org/dev"
SECRET="1e6db50c-0fee-11e5-98d0-3c15c2c6caf6"

curl -X POST -u demo:$SECRET -H "Accept: application/json" $SERVER/uaa/oauth/token
-d "grant_type=authorization_code" -d "code=XYZ"

错误和信息消息 { #webapi_error_info_messages }

Web API 使用统一的格式返回所有错误/警告和 信息性消息:

{
  "httpStatus": "Forbidden",
  "message": "You don't have the proper permissions to read objects of this type.",
  "httpStatusCode": 403,
  "status": "ERROR"
}

在这里,我们可以看到用户试图访问一个

无法访问的资源。它使用了 HTTP 状态代码 403、HTTP 状态信息 forbidden 和描述性消息。

WebMessage 属性

名称

描述

httpStatus

此响应的 HTTP 状态信息,更多信息请参见 RFC 2616(第 10 节)。 httpStatusCode
此响应的 HTTP 状态代码,更多信息请参见 RFC 2616(第 10 节)。 status
DHIS2状态,可能的值为*OK*、WARNING 或 ERROR,其中OK表示一切顺利,ERROR表示操作未完成,WARNING表示操作部分成功,如果消息包含response属性,请在那里查找更多信息。 message
用户友好型消息,说明操作是否成功。 devMessage
技术性更强、对开发人员更友好的消息(目前尚未使用)。 response
WebMessage格式未来扩展的扩展点。 日期和期间格式 { #webapi_date_period_format }
在整个 Web API 中,我们会引用日期和期间。日期格式
如下: ```
年-月-日
```

例如,如果要表达 2014 年 3 月 20 日,必须使用

2014-03-20。

下表描述了期间格式(也可通过 API 端点/api/periodTypes获取)

期间格式

期间类型

格式

示例

描述 日 yyyyMMdd 2004 年 3 月 15 日
周 yyyyWn 20040315 2004W10
2004 年第 10 周 周三开始的周 yyyyWedWn 2015WedW5
第 5 周,周三开始 周四开始的周 yyyyThuWn 2015ThuW6
第 6 周,周四开始 周六开始的周 yyyySatWn 2015SatW7
第 7 周,周六开始 周日开始的周 yyyySunWn 2015SunW8
第 8 周,周日开始 双周 yyyyBiWn 2015BiW1
2015 年第 1-2 周 月份 yyyyMM 2004 年 3 月
双月 yyyyMMB 200403 200401B
2004 年 1-2 月 季度 yyyyQn 2004Q1
2004 年 1-3 月 六个月 yyyySn 2004S1
2004 年 1 月至 6 月 4月开始的六个月 yyyyAprilSn 2004AprilS1
2004 年 4 月至 9 月 年份 yyyy 2004 年
4月开始的财政年度 yyyyApril 2004 2004
2004April 2004 年 4 月至 2005 年 3 月 7月开始的财政年度 yyyyJuly
2004July 2004 年 7 月至 2005 年 6 月 10月开始的财政年度 yyyyOct
2004Oct 2004 年 10 月至 2005 年 9 月 相对时期 { #webapi_date_relative_period_values } 在应用项目接口的某些部分,如分析资源,您可以
除固定时间段(如上定义)外,还可以使用相对时间段。
相对时间段是相对于当前日期而言的,可用于创建动态报告等。
创建动态报告。可用的相对周期值如下表所示
如下表所示。

名称

关键词

今天 今天
昨天 昨天
最近 3 天 LAST_3_DAYS
最近 7 天 LAST_7_DAYS
最近 14 天 LAST_14_DAYS
最近 30 天 LAST_30_DAYS
最近 60 天 LAST_60_DAYS
最近 90 天 LAST_90_DAYS
最近 180 天 LAST_180_DAYS
本月 THIS_MONTH
本双月 THIS_BIMONTH
上双月 LAST_BIMONTH
本季度 THIS_QUARTER
上一季度 LAST_QUARTER
本六个月 THIS_SIX_MONTHS
上六个月 LAST_SIX_MONTHS
今年的周 WEEKS_THIS_YEAR
今年的月 MONTHS_THIS_YEAR
今年的双月 BIMONTHS_THIS_YEAR
今年的季度 QUARTERS_THIS_YEAR
今年 THIS_YEAR
去年的月 MONTHS_LAST_YEAR
去年的季度 QUARTERS_LAST_YEAR
去年 LAST_YEAR
最近 5 年 LAST_5_YEARS
最近 10 年 LAST_10_YEARS
最近 12 个月 LAST_12_MONTHS
最近 6 个月 LAST_6_MONTHS
最近 3 个月 LAST_3_MONTHS
最近 6 个双月 LAST_6_BIMONTHS
最近 4 个季度 LAST_4_QUARTERS
最近 2 个六个月 LAST_2_SIX_MONTHS
本财政年度 THIS_FINANCIAL_YEAR
上一财政年度 LAST_FINANCIAL_YEAR
最近 5 个财政年度 LAST_5_FINANCIAL_YEARS
最近 10 个财政年度 LAST_10_FINANCIAL_YEARS
本周 THIS_WEEK
上周 LAST_WEEK
本双周 THIS_BIWEEK
上双周 LAST_BIWEEK
最近 4 周 LAST_4_WEEKS
最近 4 个双周 LAST_4_BIWEEKS
最近 12 周 LAST_12_WEEKS
最近 52 周 LAST_52_WEEKS
自定义日期时段 { #webapi_date_custom_date_periods } 分析 query 资源支持额外的参数来表达时段。

可以通过以下方式检索这些相对周期的 ISO 表示法 向 /api/relativePeriods/{RELATIVE_PERIOD_KEYWORD} 提出 GET 请求。

该终端支持以下参数: - startDate"(开始日期): 代表计算相对周期的起始日期。格式为yyyyy-MM-dd`。如果没有提供,默认为今天。 - financialYearStart"(财务年度开始):应为 FINANCIAL_YEAR_APRIL、FINANCIAL_YEAR_JULY、FINANCIAL_YEAR_OCTOBER 中的一个。如果未提供,则默认为 FINANCIAL_YEAR_OCTOBER。

例如,要获取从 2021-08-15 日开始的相对周期 "LAST_3_MONTHS "的 ISO 表示值,可以发出以下请求 的 ISO 表示,可以发出以下请求: GET /api/relativePeriods/LAST_3_MONTHS?startDate=2021-08-15

在这种情况下的回答是

``json { [ "202105", "202106", "202107" ] }

### 这些参数会替代默认的 `pe` 维度:

用于 `/analytics/events/query` 的 `eventDate`

用于 `/analytics/enrollments/query` 的 `enrollmentDate`

- 允许在一个或多个日期字段上添加条件并将它们合并。
- 自定义日期时段的使用 { #usage-of-custom-date-periods }

在支持自定义日期时段的资源中,有一些额外的查询参数,这些参数将被组合起来,以表达时间维度上的条件。

#### 自定义日期周期

事件查询资源

| 注册查询资源 | `eventDate`  | [x] |
|--------------------|------------------------|---------------------------|
| [ ]        | `lastUpdated`                    | [x]                       |
| [x]   | [x]                    | `lastUpdated`                       |
| [ ]    | `/api/analytics/events/query/...?..&eventDate=2021&...`                    | [x]                       |
| [x]     | `lastUpdated`                    | `lastUpdated`                       |
| [x]      | `lastUpdated`                    | `lastUpdated`                       |

可以在同一查询中合并多个时间字段:

`/api/analytics/events/query/...?..&eventDate=2021&incidentDate=202102&...`

所有这些条件都可以与 `pe` 维度相结合:

`/api/analytics/events/query/...?..&dimension=pe:TODAY&enrollmentDate=2021&incidentDate=202102&...`

支持的格式见上文 "日期和期间格式"。还提供了一种额外的格式来表达一系列日期:`yyyyMMdd_yyyyMMdd` 和 `yyyy-MM-dd_yyyy-MM-dd`。

在下面的示例中,端点将返回计划在 20210101 和 20210104 之间发生的事件:

`/api/analytics/events/query/...?..&dimension=pe:TODAY&enrollmentDate=2021&incidentDate=202102&scheduledDate=20210101_20210104&...`

当局 { #authorities }

所有可用的系统授权都可以通过以下端点列出其标识符和名称:

##     GET /api/authorities

返回格式如下:

```json
{
  "systemAuthorities": [
    {
      "id": "ALL",
      "name": "ALL"
    },
    {
      "id": "F_ACCEPT_DATA_LOWER_LEVELS",
      "name": "Accept data at lower levels"
    }
  ]
}

元数据 { #webapi_metadata }

标识符方案 { #webapi_identifier_schemes }

本节将解释标识符方案的概念。

在导入过程中,标识符方案用于将元数据对象映射到其他元数据对象, 并将元数据作为导出的一部分。请注意, 并非所有方案都适用于所有 API 调用,也并非所有方案都能同时用于输入和输出。 在后续章节中会解释各种 API 端点支持的方案。

下面列出了可用的全套标识符方案对象类型,

使用在查询中使用的属性名称:

idScheme

dataElementIdScheme

  • 描述
  • DateTime
  • programIdScheme
  • programStageIdScheme
  • Can either be VALIDATE which will report errors in the payload without making changes to the database or COMMIT (default) which will validate the payload and make changes to the database.
  • IdScheme used for all metadata references unless overridden by a metadata specific parameter. Default is UID.
  • 通用 idScheme 适用于所有类型的对象, 但可以被特定的对象类型方案覆盖。
  • 所有参数的默认方案是 UID(稳定的 DHIS2 标识符)。支持的标识符方案如下表所示:

表:标识符方案值

方案

描述

ID, UID Parameter name
CODE 与 DHIS2 编码匹配,主要用于与外部系统交换数据。
NAME 在 DHIS2 名称上匹配,请注意这使用的是可用的 object.name,而不是翻译后的名称。还请注意,名称并不总是唯一的,在这种情况下,不能使用它们。
ATTRIBUTE:ID 根据元数据属性进行匹配,需要将此属性分配给要匹配的类型,同时将唯一属性设置为 true。它的主要用途是与外部系统交换数据,与 CODE 相比,它有一些优势,因为可以添加多个属性,所以可以用于与多个系统同步。
请注意,标识符方案不是一个独立的功能,需要与数据值导入、元数据导入和
GeoJson 导入等资源结合使用。 例如,指定 CODE 作为通用 id 方案并覆盖
使用 UID 作为组织单位 ID 方案,您可以使用这些查询
参数:
?idScheme=CODE&orgUnitIdScheme=UID

再举一个例子,为组织单位 id 指定一个属性 方案,数据元素 id 方案的代码并使用默认 UID id 作为所有其他对象的方案,您可以使用这些参数:

?orgUnitIdScheme=ATTRIBUTE:j38fk2dKFsG&dataElementIdScheme=CODE

浏览Web API { #webapi_browsing_the_web_api }

浏览 Web API 的入口点是 /api。这个资源 提供所有可用资源的链接。四种资源表示 格式始终适用于所有资源:HTML、XML、JSON 和 JSONP。某些资源将具有其他可用格式,例如 MS Excel、PDF、CSV 和 PNG。要从 Web 浏览器探索 API,请导航 到 /api 入口点并按照链接访问您想要的 资源,例如/api/dataElements。对于所有返回元素列表的资源, 某些查询参数可用于修改响应:

表:查询参数

参数

选项值

默认值 描述 paging Parameter name
true 表示是否返回分页的元素列表。 Tracked Entity UIDS 数字
定义要返回的页码。 order 1 数字
定义每页返回的元素数量。 order 50 property:asc/iasc/desc/idesc
iasc 和 idesc 是不区分大小写的排序。如果需要对多个属性进行排序,请使用逗号将它们分开。 如何使用这些参数获取完整列表的示例
XML 响应格式的数据元素组: /api/dataElementGroups.xml?links=false&paging=false

您可以在 name 属性上查询元素,而不是返回 使用 query 查询参数的完整元素列表。在这个例子中 我们查询名称中带有“贫血”一词的所有数据元素:

/api/dataElements?query=贫血

您可以像这样获取特定页码和页面大小的对象:

/api/dataElements.json?page=2&pageSize=20

您可以像这样完全禁用分页:

/api/indicatorGroups.json?paging=false

要基于特定属性对结果进行排序:

/api/indicators.json?order=shortName:desc

首先根据创建的日期时间属性排序(降序),然后根据名称属性排序(升序):

/api/indicators.json?order=created:desc,name:asc

您可以通过以下方式在所有对象类型中根据对象的 ID 查找对象 identifiableObjects 资源:

/ api / identifiableObjects / <id>

翻译 { #webapi_translation }

DHIS2 支持数据库内容的翻译,如数据元素、指标和计划、 指标和项目。网络应用项目接口中的所有元数据对象都有 属性,这些属性包括 displayName, displayShortName, displayDescription 和 displayFormName(用于数据元素和跟踪实体属性)。

表格翻译选项

参数

价值观

默认值 译 Parameter name
启用翻译。请注意,默认情况下这是关闭的(在其他端点,默认情况下是打开的)。 表示是否返回分页的元素列表。 使用的本地语言
从用户本地语言更改为自定义本地语言。 翻译API { #webapi_translation_api } 对象的翻译呈现为对象本身的一部分
在* translation *数组中。请注意,
JSON / XML有效负载的*翻译*数组通常为您预先过滤,这意味着它们不能直接用于导入/导出翻译(因为那样会
通常会覆盖当前用户以外的语言环境)。

在用户语言环境中过滤了转换数组的数据元素示例:

{
  "id": "FTRrcoaog83",
  "displayName": "Accute French",
  "translations": [
    {
      "property": "SHORT_NAME",
      "locale": "fr",
      "value": "Accute French"
    },
    {
      "property": "NAME",
      "locale": "fr",
      "value": "Accute French"
    }
  ]
}

转换关闭的数据元素示例:

{
  "id": "FTRrcoaog83",
  "displayName": "Accute Flaccid Paralysis (Deaths < 5 yrs)",
  "translations": [
    {
      "property": "FORM_NAME",
      "locale": "en_FK",
      "value": "aa"
    },
    {
      "property": "SHORT_NAME",
      "locale": "en_GB",
      "value": "Accute Flaccid Paral"
    },
    {
      "property": "SHORT_NAME",
      "locale": "fr",
      "value": "Accute French"
    },
    {
      "property": "NAME",
      "locale": "fr",
      "value": "Accute French"
    },
    {
      "property": "NAME",
      "locale": "en_FK",
      "value": "aa"
    },
    {
      "property": "DESCRIPTION",
      "locale": "en_FK",
      "value": "aa"
    }
  ]
}

请注意,即使您得到未过滤的结果,并且正在使用 适当的类型端点,即我们不允许的 /api/dataElements 更新,因为这样做很容易犯错误并覆盖 其他可用的语言环境。

要阅读和更新翻译,您可以使用特殊翻译 每个对象资源的端点。可以通过*GET*或访问 在适当的/ api / <object-type> / <object-id> / translations端点上* PUT *。

例如,对于标识符为 FTRrcoaog83 的数据元素,您可以使用 /api/dataElements/FTRrcoaog83/translations来获取和更新翻译。 翻译。可用的字段有:property (可选 NAME、SHORT_NAME、FORM_NAME、DESCRIPTION)、locale(支持任何有效的 locale"(支持任何有效的 locale ID)和已翻译的属性 value。

法语语言环境的NAME属性示例:

{
  "property": "NAME",
  "locale": "fr",
  "value": "Paralysie Flasque Aiguë (Décès <5 ans)"
}

然后将此有效负载添加到翻译数组中,并发回 到适当的端点:

{
  "translations": [
    {
      "property": "NAME",
      "locale": "fr",
      "value": "Paralysie Flasque Aiguë (Décès <5 ans)"
    }
  ]
}

对于ID为* FTRrcoaog83 的数据元素,您可以 PUT *此代码为 / api / dataElements / FTRrcoaog83 / translations。确保发送全部 特定对象的翻译,而不仅仅是单个语言环境的翻译 (否则,您可能会覆盖其他区域的现有语言环境 语言环境)。

如果数据值已成功保存或更新,则状态代码将为204 No Content,如果存在验证错误(例如,同一语言环境有多个SHORT_NAME),则状态代码将为404 Not Found。

Web API版本 { #webapi_api_versions }

网络 API /api可与 DHIS2 版本号一起使用,例如

/api/42/dataElements

支持版本 28-43。调用带有或不带版本的端点不会改变 API 的行为。无论使用哪种方法,行为都是一样的。我们的目标是不再支持带版本的 API 调用,因此请使用不带版本号的 API 调用。
支持使用版本是由于传统的设计,并没有按照最初的设想发展。

元数据对象过滤器 { #webapi_metadata_object_filter }

要过滤元数据,可以对返回的元数据列表应用多种过滤操作。 过滤器的格式很简单,遵循以下模式: property:operator:value,其中 property 是要过滤的元数据属性, operator 是要执行的比较运算符,value 是要匹配的值。

请参阅 "模式"部分,了解哪些属性可用。

除列出的属性外,筛选器还可应用于自定义属性 值,方法是使用属性的 ID 作为属性名。

还支持递归过滤,即对关联对象或对象集合进行过滤。

表:可用操作符

操作符

类型

所需值 描述 eq Parameter name
true 不等于 Tracked Entity UIDS 字符串、布尔值、整数、浮点、枚举、集合(检查大小)、日期
true 不等于 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串、布尔值、整数、浮点、枚举、集合(检查大小)、日期
true 不等于 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串、布尔值、整数、浮点、集合(检查大小)、日期
true 小于 Tracked Entity UIDS 字符串、布尔值、整数、浮点、集合(检查大小)、日期
true 小于 Tracked Entity UIDS 字符串、布尔值、整数、浮点、集合(检查大小)、日期
true 小于 Tracked Entity UIDS 字符串、布尔值、整数、浮点、集合(检查大小)、日期
true 小于 Tracked Entity UIDS 所有
false * subjectTemplate 所有
false * subjectTemplate 集合
false 集合为空 subjectTemplate 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串
true 不区分大小写的字符串结尾匹配 Tracked Entity UIDS 字符串、布尔值、整数、浮点、日期
描述 查找匹配 1 个或多个值的对象 Tracked Entity UIDS 字符串、布尔值、整数、浮点、日期
true 查找匹配 1 个或多个值的对象 Tracked Entity UIDS 获取ID属性为ID1或ID2的数据元素:
/api/dataElements?filter=id:eq:ID1&filter=id:eq:ID2

获取名称属性为 MyDataElement 的数据元素,忽略大小写:

/api/dataElements?filter=name:ieq:mydataelement

获取具有 ID1 数据集的所有数据元素:

/api/dataElements?filter=dataSetElements.dataSet.id:eq:ID1

获取所有使用聚合运算符 sum 和值类型为 int 的数据元素:

/api/dataElements.json?filter=aggregationOperator:eq:sum&filter=type:eq:int

您可以在集合内进行筛选,例如,要获取属于 ANC 数据元素组的数据元素, 可以使用相关数据元素组的 id 属性进行查询:

/api/dataElements.json?filter=dataElementGroups.id:eq:qfxEYY9xAl6

要获取元数据属性中具有特定属性值的数据元素, 可使用相同的集合查询语法指定属性 ID 和属性值的过滤器:

/api/dataElements.json?filter=attributeValues.attribute.id:eq:n2xYlNbsfko&filter=attributeValues.value:eq:AFP

获取已设置选项集的数据元素:

/api/dataElements?filter=optionSet:!null

由于默认情况下所有运算符都是 AND,因此您无法直接找到匹配 多个 id 的数据元素,为此您可以使用 in 操作符:

/api/dataElements.json?filter=id:in:[fbfJHSPpUQD,cYeuwXTCPkU]

逻辑运算符 { #webapi_metadata_logical_operator }

如前一节所述,过滤器应用的默认逻辑运算符 是 AND,这意味着所有对象过滤器必须都 匹配。但是,在某些情况下,您希望匹配其中之一 几个过滤器(可能是 id 和 code 字段),在这些情况下,它是 可以将根逻辑运算符从 AND 切换为 OR 使用 rootJunction 参数。

示例:正常过滤,其中 id 和 code 必须匹配才能具有

结果返回

/api/dataElements.json?filter=id:in:[id1,id2]&filter=code:eq:code1

示例:过滤逻辑运算符已切换为 OR 的位置 现在只有一个过滤器必须匹配才能产生结果 回

/api/dataElements.json?filter=id:in:[id1,id2]&filter=code:eq:code1&rootJunction=OR

可识别的令牌过滤器 { #identifiable-token-filter }

除了上述基于特定属性的过滤之外, 我们还通过* token 基于 AND 过滤了一组 属性:ID,代码和名称(如果可用,还包括shortName)。这些 属性通常称为*可识别。这个想法是为了 过滤ID,名称,代码或简称中包含某些内容的元数据。

示例:过滤所有包含 2nd 的数据元素

如下: id,name,code,shortName

/api/dataElements.json?filter=identifiable:token:2nd

也可以指定多个过滤值。

示例:获取在任何 identifiable 属性中找到 ANC visit 的所有数据元素。系统返回所有数据元素,其中在可识别属性中的任何地方都可以找到令牌(ANC 和访问)。

/api/dataElements.json?filter=identifiable:token:ANC访问

也可以将可识别过滤器与基于属性的过滤器结合起来,并期望应用 rootJunction。

/api/dataElements.json?filter=identifiable:token:ANC visit&filter = displayName:ilike:tt1

/api/dataElements.json?filter=identifiable:token:ANC访问
  &filter = displayName:ilike:tt1&rootJunction = OR

元数据字段过滤器 { #webapi_metadata_field_filter }

在许多情况下,元数据的默认视图可能过于冗长。 冗长。客户可能只需要每个对象中的几个字段,并希望从响应中删除不必要的字段。 从响应中删除不必要的字段。要了解每个对象有哪些字段 请参阅 "模式"部分。 除了列出的属性外,还可以通过使用属性 属性 ID 作为属性名称。

include/exclude 的格式允许无限递归。要过滤可以在"根"级只使用字段的名称,

例如,?fields=id,name 只显示每个对象的id和name字段。对于集合或复杂对象,可以使用以下格式 ?fields=id,name,dataSets[id,name],这将返回根对象的name和id字段。并且包括该对象的所有数据集的 id and name
可以使用感叹号操作符进行否定操作,我们有一组字段选择预设。支持 XML 和 JSON 格式。

示例:在指标资源上获取id和name:

/ api / indicators?fields = id,名称

示例:从数据元素中获取 id 和 name,并从相关数据集中获取 id 和 name:

/ api / dataElements?fields = id,name,dataSets [id,name]

示例:获取用户定义属性的 id、name 和值 ID 为 DnrLSdo4hMl 的组织单位的用户定义属性值:

/api/organisationUnits?fields=id,name,DnrLSdo4hMl

然后,该属性将作为每个匹配对象的属性 DnrLSdo4hMl 包含在响应中。 属性。可以使用 rename 转换器进行重命名,如下一节所示。

要从输出中排除字段,可以使用感叹号!。 操作符。这是在查询中的任何地方都允许的,而根本不会 包括该属性,因为它可能已经插入了某些 预设。

一些预设(选定的字段组)可用并且可以应用 使用: 运算符。

表格属性操作符

操作员

描述

所需值 Parameter name
<object>[<field-name>, ...] 包含一个集合中的字段(将应用于该集合中的每个对象),或只包含一个对象上的字段。
!<field-name>,<object>[!<field-name> 请勿包含此字段名称,它也适用于对象/集合内部。在使用预设包含字段时非常有用。
*,<object>[*] 包括某个对象上的所有字段,如果应用于某个集合,则会包括该集合中所有对象上的所有字段。
:<preset> 别名,用于选择多个字段。目前有三种预设,请参阅下表了解说明。
表格字段预设 预设

描述

一应俱全 Parameter name
* 所有的别名
可识别 包括 id、名称、代码、创建、最后更新和最后更新由字段
可命名 包括 id、名称、简称、代码、描述、创建和最后更新字段
持续 返回对象的所有持久化属性,不考虑对象是否是关系的所有者。
所有者 返回对象上的所有持久化属性,其中该对象是所有属性的所有者,此有效负载可用于通过 API 进行更新。
示例:包括数据集中除组织单位以外的所有字段: / api / dataSets?fields =:all,!organizationUnits

示例:仅包含ID,名称和数据集中的组织单位集合,但不包含组织单位中的ID:

/ api / dataSets / BfMAe6Itzgt?fields = id,name,organisationUnits [:all,!id]

示例:包括所有指标的可命名属性:

/api/indicators.json?fields=:nameable

字段转换器 { #webapi_field_transformers }

字段转换器可用于转换属性。语法说明如下:

/api/dataElements/ID?fields=idrename(i),namerename(n)

这会将 id 属性重命名为 i,将 name 属性重命名为 n。

/api/dataElementGroups?fields=id,displayName,dataElements~paging(1;20)

/api/dataElementGroups.json?fields=id,displayName,dataElements~isNotEmpty~rename(haveDataElements)

下表列出了支持的转换器操作符。

表:可用转换器

名称

参数

类型 size Parameter name
isEmpty 字符串或集合是否为空
isNotEmpty 字符串或集合是否不为空
rename 参数 1:名称
重命名属性名称 paging 参数 1:页码,参数 2:页面大小
true pluck 可选参数 1:字段名
将对象数组转换为对象选定字段的数组。默认情况下,使用集合返回的第一个字段(通常是 ID)。 keyBy 可选参数 1:字段名
将对象数组转换为以字段名(默认 id)为键的对象。这对 JavaScript 中的快速查找非常有用。 keyBy 变压器使用示例如下。

获取集合的大小:

/api/dataElements?fields=dataSets~size

测试集合是否为空:

/api/dataElements?fields=dataSets~isEmpty

测试集合是否为空:

/api/dataElements?fields=dataSets~isNotEmpty

重命名属性

/api/dataElements/ID?fields=id~rename(i),name~rename(n)

对集合进行分页:

/api/dataElementGroups?fields=id,displayName,dataElements~paging(1;20)

获取包含组织单位 ID 的数组:

/api/categoryOptions.json?fields=id,organisationUnits~pluck

获取包含组织单位名称的数组:

/api/categoryOptions.json?fields=id,organisationUnits~pluck[name]。

通过d字段键入 dataElements 数组:

/api/dataElementGroups.json?fields=id,name,dataElements~keyBy[id,name,valueType]。

通过valueType字段键入 dataElements 数组,因为多次点击这将生成(数据元素的)数组:

/api/dataElementGroups.json?fields=id,name,dataElements~keyBy(valueType)[id,name,valueType]。

元数据创建,读取,更新,删除,验证 { #webapi_metadata_crud }

DHIS2 中的所有元数据实体都有自己的 API 端点,支持 CRUD 操作(创建、读取、更新和删除)。端点 URL 遵循以下格式:

/ api /

entityName 使用驼峰命名法。例如,端点 对于_数据元素_是:

/ api / dataElements

** 注意: ** 更新对象时,所有现有属性值都将被覆盖,即使新值为空。如果要对对象进行部分更新,请使用 JSON Patch API。

创建/更新参数 { #webapi_metadata_create_update }

以下请求查询参数可用于所有元数据端点。

表:可用的查询过滤器

参数

类型

需要 Potential duplicate status 检索和删除项目通知模板 Attribute identifiers Parameter name
假 项目阶段 subjectTemplate 表示是否返回分页的元素列表。 枚举
Sets import strategy, CREATE_AND_UPDATE will try and match on identifier, if it doesn't exist, it will create the object. 创建_并_更新|创建|更新|删除 subjectTemplate 创建和更新对象 { #webapi_creating_updating_objects } 要创建新对象,您需要知道端点、类型
格式,并确保您拥有所需的权限。作为
例如,我们将创建和更新一个*常量*。为了弄清楚
格式,我们可以使用新的 schema 端点来获取格式
描述。因此,我们将从获取该信息开始:

http:// /api/schemas/constant.json

从输出中,您可以看到创建所需的权限 是F_CONSTANT_ADD,重要的属性是:name 和 价值。由此,我们可以创建一个 JSON 负载并将其保存为文件 称为constant.json:

{
  "name": "PI",
  "value": "3.14159265359"
}

与XML有效内容相同的内容:

<constant name="PI" xmlns="http://dhis2.org/schema/dxf/2.0">
  <value>3.14159265359</value>
</constant>

我们现在准备通过发送 POST 请求来创建新的*常量* 使用curl 的带有JSON 有效负载的constants端点:

curl -d @constant.json "http://server/api/constants" -X POST
  -H "Content-Type: application/json" -u user:password

将常量发布到演示中的具体示例 服务器:

curl -d @constant.json "https://play.dhis2.org/api/constants" -X POST
  -H "Content-Type: application/json" -u admin:district

如果一切顺利,您应该看到类似以下的输出:

{
  "status": "SUCCESS",
  "importCount": {
    "imported": 1,
    "updated": 0,
    "ignored": 0,
    "deleted": 0
  },
  "type": "Constant"
}

更新过程将完全相同,您进行更改 到 JSON/XML 负载,找出常量的 ID,然后 向端点发送包含 ID 的 PUT 请求:

curl -X PUT -d @pi.json -H "Content-Type: application/json"
  -u user:password "http://server/api/constants/ID"

删除物件 { #webapi_deleting_objects }

删除对象非常简单,您需要知道 ID 和你要删除的类型的端点,让我们继续我们的 上一节中的示例并使用*常量*。让我们假设 id 是 abc123,那么你需要做的就是发送 DELETE 对端点的请求 + id:

```bash

curl -X DELETE -u user:password "http://server/api/constants/ID"

成功删除应返回HTTP状态204(无内容)。

在集合中添加和删除对象 { #webapi_adding_removing_objects_collections } 

集合资源允许您修改集合
对象。

### 添加或删除单个对象 { #webapi_collections_adding_removing_single_objects } 

为了在对象集合中添加或删除对象,您
可以使用以下
    图案:

####     / api / {collection-object} / {collection-object-id} / {collection-name} / {object-id}

应该使用POST方法添加,使用DELETE方法删除
一个东西。当对象之间存在多对多关系时,
您必须首先确定哪个对象拥有该关系。如果不是
清除这是哪个对象,尝试两种方式调用以查看哪个有效。

模式的组成部分是:

集合对象:拥有您的集合的对象类型

想修改。

  - 集合对象 id:拥有该对象的对象的标识符
    要修改的集合。

  - 集合名称:您要修改的集合的名称。
    object id:要添加或删除的对象的标识符

  - 从集合。

  - 例如,为了删除标识符为 IDB 的数据元素
从具有标识符 IDA 的数据元素组中,您可以执行 DELETE
要求:
        删除/ api / dataElementGroups / IDA / dataElements / IDB

将带有标识符 IDB 的类别选项添加到带有
标识符 IDA 你可以做一个 POST
要求:

    POST / api / categories / IDA / categoryOptions / IDB

添加或删除多个对象 { #webapi_collections_adding_removing_multiple_objects } 

您可以在一个请求中从集合中添加或删除多个对象
具有这样的有效载荷:

#### ```json
{
  "identifiableObjects": [{
      "id": "IDA"
    }, {
      "id": "IDB"
    }, {
      "id": "IDC"
    }
  ]
}

使用此有效负载,您可以添加,替换或删除项目:

添加项目:

POST / api / categories / IDA / categoryOptions

更换物品:

{
  "additions": [{
      "id": "IDA"
    }, {
      "id": "IDB"
    }, {
      "id": "IDC"
    }
  ],
  "deletions": [{
      "id": "IDD"
    }, {
      "id": "IDE"
    }, {
      "id": "IDF"
    }
  ]
}

删除 项目:

删除/ api / categories / IDA / categoryOptions

在单个请求中添加和删除对象 { #webapi_collections_adding_removing_objects_single_request }

您可以在单个 POST 中从集合中添加和删除对象 请求到以下 URL:

POST / api / categories / IDA / categoryOptions

有效负载格式为:

{
  "additions": [{
      "id": "IDA"
    }, {
      "id": "IDB"
    }, {
      "id": "IDC"
    }
  ],
  "deletions": [{
      "id": "IDD"
    }, {
      "id": "IDE"
    }, {
      "id": "IDF"
    }
  ]
}

验证有效载荷 { #webapi_validating_payloads }

DHIS 2 支持元数据有效载荷的系统范围验证,这意味着 将检查 API 端点上的创建和更新操作 允许进行更改之前的有效负载。找出哪些验证 为特定端点准备好了,看看/api/schemas 端点,即要找出数据元素具有哪些约束,您 会去/api/schemas/dataElement。

您还可以手动验证您的有效负载,方法是将其发送到适当的

架构端点。如果您想从创建中验证常量 之前的部分,您可以这样发送:

POST / api / schemas / constant

一个简单的(非验证)示例为:

curl -X POST -d "{\"name\": \"some name\"}" -H "Content-Type: application/json"
  -u admin:district "https://play.dhis2.org/dev/api/schemas/dataElement"

这样就能得到结果:

[
   {
      "message" : "Required property missing.",
      "property" : "type"
   },
   {
      "property" : "aggregationOperator",
      "message" : "Required property missing."
   },
   {
      "property" : "domainType",
      "message" : "Required property missing."
   },
   {
      "property" : "shortName",
      "message" : "Required property missing."
   }
]

部分更新 { #webapi_partial_updates }

对于处理元数据的 API 端点,我们支持使用 JSON 补丁 标准 进行部分更新 (PATCH)。有效负载基本上概述了您想要应用于现有元数据对象的一组操作。有关 JSON 补丁的详细信息和示例,请参阅 jsonpatch.com。支持三个运算符:添加、删除和替换。

下面是几个与 DHIS2 相关的示例。请注意,对有效载荷的任何更新都应视为 HTTP PUT 操作,即任何突变都必须产生有效的 PUT 元数据有效载荷。

JSON 补丁的默认 importReportMode(导入报告模式)是 ERRORS_NOT_OWNER,这意味着在更新任何不属于该特定对象的属性时(例如,试图将指标组直接添加到指标中),会出现错误。

根据 JSON 补丁规范,发送补丁时必须始终使用 mimetype application/json-patch+json。

例子 { #examples }

更新数据元素的名称和值类型{ #update-name-and-value-type-of-data-element }

```

/api/dataElements.csv?fields=id,displayName,dataElementGroups

##### ```json
[
  {"op": "add", "path": "/name", "value": "New Name"},
  {"op": "add", "path": "/valueType", "value": "INTEGER"}
] 

从 orgUnit 组中删除特定 orgUnit{ #remove-a-specific-orgunit-from-an-orgunit-group }

PATCH /api/dataElementGroups/{id}
```json

[ {"op": "add", "path": "/dataElements/-", "value": {"id": "data-element-id"}} ]

更改数据元素的域和值类型{ #change-domain-and-value-type-of-a-data-element } 
PATCH /api/dataElementGroups/{id}
##### ```json
[
  {"op": "remove", "path": "/dataElements"}
]

更改数据元素的域和值类型{ #change-domain-and-value-type-of-a-data-element }

PATCH /api/dataElements/{id}
```json

[ {"op": "add", "path": "/domainType", "value": "TRACKER"}, {"op": "add", "path": "/valueType", "value": "INTEGER"} ]

从 orgUnit 组中删除特定 orgUnit{ #remove-a-specific-orgunit-from-an-orgunit-group } 
PATCH /api/organisationUnitGroups/{id}
##### ```json
[
  {"op": "remove", "path": "/organisationUnits/1"}
]

受阻 将 dataElementGroup 添加到 dataElement{ #blocked-add-dataelementgroup-to-dataelement }

PATCH /api/dataElements/{id}?importReportMode=ERRORS_NOT_OWNER

```json

[ {"op": "add", "path": "/dataElementGroups/-", "value": {"id": "data-element-group-id"}} ]

按 id 删除收藏项{ #remove-collection-item-by-id } 
PATCH /api/dataElements/{id}?importReportMode=ERRORS_NOT_OWNER
#### ```json
[
    {"op": "add", "path": "/dataElementGroups/0", "value": {"name": "new-name"}}
]

按 id 删除收藏项{ #remove-collection-item-by-id }

补丁 /api/dataSets/{id}?importReportMode=ERRORS_NOT_OWNER

```json

[ {"op": "remove-by-id", "path": "/organisationUnits", "id": "u6CvKyF0Db5"} ]

回应

如果`path`属性无效或不存在,则修补服务将返回如下错误。

#### ```
补丁 /api/dataSets/{id}?importReportMode=ERRORS_NOT_OWNER
[
    {"op": "remove-by-id", "path": "/test", "id": "u6CvKyF0Db5"}
]

回应

{
    "httpStatus": "Bad Request",
    "httpStatusCode": 400,
    "status": "ERROR",
    "message": "Invalid path /test"
}
元数据 CSV 导出{ #webapi_metadata_csv_export } CSV字段过滤与CSV(请注意,在/api/metadata端点上使用CSV不受支持)几乎相同,但字段转换尚不支持。

对于支持CSV的端点(如/api/dataElements /api/organisationUnits等我们的元数据端点),您可以使用Accept头部和值text/csv,或者您可以使用扩展名.csv。请注意,不支持复杂对象,我们仅支持id-object集合(因此将返回一个UID列表)。

名称

选项

类型 用户设置 { #webapi_user_settings } Parameter name
默认过滤器是id,displayName skipHeader 假/真
标题(包含列名)是否应包括在内 下载 默认值: .
立柱分离器 数组分隔符 默认值:;
如果其中一个字段是一个 ID 对象集合,该分隔符将分隔所有 UID 例子 { #examples } 获取包括组关联在内的所有数据元素{ #get-all-data-elements-including-their-group-associations }

```

/api/dataElements.csv?fields=id,displayName,dataElementGroups

#### 获取所有组织单位,包括几何(将被忽略){ #get-all-org-units-including-geometry-which-will-get-ignored } 
/api/organisationUnits.csv?fields=id,displayName,organisationUnitGroups,geometry
#### 元数据导出 { #webapi_metadata_export } 

本节介绍了可在以下位置获得的元数据 API
`/api/元数据`。支持 XML 和 JSON 资源表示。

##     / api /元数据

最常用的参数在下面的“导出参数”中描述
桌子。您还可以使用以下方法将其应用于所有可用类型
`type:fields=<filter>` 和 `type:filter=<filter>`。你也可以
通过设置 `type=true|false` 启用/禁用某些类型的导出。

表:导出参数

名称

选项

| 类型 | 用户设置 { #webapi_user_settings }  | Parameter name |
|---|---|---|
| 默认过滤器是`id,displayName` | 过滤 | 与元数据对象过滤器相同 |
| 数据值 | 订单 | 与元数据顺序相同 |
| iasc 和 idesc 是不区分大小写的排序。如果需要对多个属性进行排序,请使用逗号将它们分开。 | 译 | 假/真 |
| 启用翻译。请注意,默认情况下这是关闭的(在其他端点,默认情况下是打开的)。 | 下载 | <locale\> |
| 从用户本地语言更改为自定义本地语言。 | 默认 | 包括/排除 |
| 是否应在有效载荷中包含自动生成的类别对象。如果您要在两个非同步实例之间移动元数据,可能需要将其设置为 EXCLUDE,以方便处理这些生成的对象。 | 跳过共享 | 假/真 |
| 跳过共享属性,更新时不合并共享,创建新对象时不添加用户组访问权限。 | 下载 | NON_NULL, ALWAYS, NON_EMPTY |
| *NON_NULL* 包括非空属性,*ALLWAYS* 包括所有属性,*NON_EMPTY* 包括非空属性(不包括长度为 0 的字符串或空集合)。 | 下载 | 假/真 |
| 启用此功能将添加 HTTP 标头 Content-Disposition,指定数据应作为附件处理,并由网络浏览器提供下载。 | 下载 | 导出所有元数据。小心,因为响应可能非常大,具体取决于
关于您的元数据配置: |

###     / api /元数据

导出由lastUpdated降序排列的所有元数据:

表:导出参数

导出仅包括指标和指标组的元数据:

    / api / metadata?indicators = true&indicatorGroups = true

导出所有数据元素的id和displayName,按displayName排序:

    / api / metadata?dataElements:fields = id,name&dataElements:order = displayName:desc

导出名称以“ ANC”开头的数据元素和指示符:

    / api / metadata?filter = name:^ like:ANC&dataElements = true&indicators = true

具有依赖项的元数据导出 { #webapi_dataset_program_export_dependencies } 

当您想交换数据集、项目、类别组合、仪表盘、选项集或数据元素组的元数据时、
仪表板、选项集或数据元素组的元数据时
时,有六个专用端点可供使用:

### ```
/api/dataSets/{id}/metadata.json

/api/programs/{id}/metadata.json

/api/categoryCombos/{id}/metadata.json

/api/dashboards/{id}/metadata.json

/api/optionSets/{id}/metadata.json

/api/dataElementGroups/{id}/metadata.json

然后可以使用/ api / metadata导入这些导出。

这些端点还支持以下参数:

表:导出参数

名称

选项

类型 用户设置 { #webapi_user_settings } Parameter name
跳过共享属性,更新时不合并共享,创建新对象时不添加用户组访问权限。 下载 NON_NULL, ALWAYS, NON_EMPTY
启用此功能将添加 HTTP 标头 Content-Disposition,指定数据应作为附件处理,并由网络浏览器提供下载。 下载 导出所有元数据。小心,因为响应可能非常大,具体取决于
关于您的元数据配置:

/ api /元数据

导入器允许您导入元数据有效负载,其中可能包括许多 不同的实体和每个实体的任意数量的对象。元数据导出 元数据导出API生成的可以直接导入。

表:导出参数

表:导入参数

名称

选项(第一项为默认值)

类型 导入模式 Parameter name
设置整体导入模式,决定是否仅 VALIDATE 或也 COMMIT 元数据,这与我们旧的 dryRun 标志具有相似的功能。 标识符 uid、代码、自动
设置用于引用匹配的标识符方案。AUTO表示先尝试UID,再尝试 CODE。 导入报告模式 错误、全部、调试
设置 ImportReport 模式,控制导入完成后报告的内容。ERRORS只包含有错误的对象的 ObjectReport 报告。FULL返回所有已导入对象的 ObjectReport ,而 DEBUG则返回相同对象名称(如果有)。 预热模式 参考、全部、无
设置预热器模式,用于指示是否应该对 ALL 进行预热(就像以前使用 preheatCache=true 一样)或对对象进行更智能的扫描以查看要预热的内容(现在是默认设置),将其设置为不推荐使用无。 导入策略 CREATE_AND_UPDATE, CREATE, UPDATE, DELETE
Sets import strategy, CREATE_AND_UPDATE will try and match on identifier, if it doesn't exist, it will create the object. 原子模式 全部,无
设置原子模式,在旧的导入器中,我们总是进行*best effort*导入,这意味着即使某些引用不存在,我们仍然会导入(即数据元素组导入时缺少数据元素)。新进口商的默认设置是不允许这样做,并且类似地拒绝任何验证错误。设置 NONE 模式模拟了旧的行为. 冲洗模式 自动,目标
设置刷新模式,控制何时刷新内部缓存。*强烈*建议将其保留为AUTO(这是默认设置)。仅将 OBJECT 用于调试目的,您会看到休眠异常并想查明堆栈发生的确切位置(休眠只会在刷新时抛出,因此很难知道哪个对象有问题)。 跳过共享 假,真
跳过共享属性,更新时不合并共享,创建新对象时不添加用户组访问权限。 跳过验证 假,真
跳过导入的验证。不推荐。 跳过验证 假,真
异步导入时,会立即返回一个 Location 标头,指向 importReport 的位置。有效载荷还包含一个已创建任务的 json 对象。 跳过验证 无、当前、选定
允许你覆盖正在导入的每个对象的用户属性,选项包括 NONE(不做任何操作)、CURRENT(使用导入用户)、SELECTED(使用 overrideUser=X 选择特定用户)。 覆盖用户 用户 ID
如果 userOverrideMode 为 SELECTED,则使用此参数选择要覆盖的用户。 > NOTE When updating objects, all property values will be overwritten even if the new values are null. Please use JSON Patch API in case you want do partial update to an object. 要导入的元数据负载的示例如下所示。注意如何
每个实体类型都有自己的属性和一个对象数组:
{
  "dataElements": [
    {
      "name": "EPI - IPV 3 doses given",
      "shortName": "EPI - IPV 3 doses given",
      "aggregationType": "SUM",
      "domainType": "AGGREGATE",
      "valueType": "INTEGER_ZERO_OR_POSITIVE"
    },
    {
      "name": "EPI - IPV 4 doses given",
      "shortName": "EPI - IPV 4 doses given",
      "aggregationType": "SUM",
      "domainType": "AGGREGATE",
      "valueType": "INTEGER_ZERO_OR_POSITIVE"
    }
  ],
  "indicators": [
    {
      "name": "EPI - ADS stock used",
      "shortName": "ADS stock used",
      "numerator": "#{LTb8XeeqeqI}+#{Fs28ZQJET6V}-#{A3mHIZd2tPg}",
      "numeratorDescription": "ADS 0.05 ml used",
      "denominator": "1",
      "denominatorDescription": "1",
      "annualized": false,
      "indicatorType": {
        "id": "kHy61PbChXr"
      }
    }
  ]
}

将此有效负载发布到元数据端点时,响应将包含 有关导入过程中使用的参数的信息和每个摘要 实体类型,包括创建、更新、删除和 忽略:

{
  "importParams": {
    "userOverrideMode": "NONE",
    "importMode": "COMMIT",
    "identifier": "UID",
    "preheatMode": "REFERENCE",
    "importStrategy": "CREATE_AND_UPDATE",
    "atomicMode": "ALL",
    "flushMode": "AUTO",
    "skipSharing": false,
    "skipTranslation": false,
    "skipValidation": false,
    "metadataSyncImport": false,
    "firstRowIsHeader": true,
    "username": "UNICEF_admin"
  },
  "status": "OK",
  "typeReports": [
    {
      "klass": "org.hisp.dhis.dataelement.DataElement",
      "stats": {
        "created": 2,
        "updated": 0,
        "deleted": 0,
        "ignored": 0,
        "total": 2
      }
    },
    {
      "klass": "org.hisp.dhis.indicator.Indicator",
      "stats": {
        "created": 1,
        "updated": 0,
        "deleted": 0,
        "ignored": 0,
        "total": 1
      }
    }
  ],
  "stats": {
    "created": 3,
    "updated": 0,
    "deleted": 0,
    "ignored": 0,
    "total": 3
  }
}

GeoJSON 导入 { #geojson-import }

GeoJSON 导入用于将几何数据附加到组织单位。

对于批量导入,需要一个带有特征集合的 GeoJSON 文件。

该集合中的每个地物都需要指向其应链接到的组织单位的引用。 的引用。

默认情况下,文件中的几何图形存储为组织单位的几何图形属性。要存储额外的几何图形,可以创建GEOJSON类型的属性。当使用属性时,文件中的所有几何图形都存储为相同的属性,该属性提供了一个附加参数attributeId。

GeoJSON 批量数据导入{ #webapi_geojson_bulk_import }

表:导入参数

名称

类型

| 类型 | Potential duplicate status | 仪表板资源将提供仪表板列表。请记住 仪表板对象是共享的,因此列表将受 当前已验证的用户。您可以检索有关一个的更多信息 特定的仪表板,请点击其链接,类似于: | Parameter name | |-------------------|--------------------------------|---|-----------------------------------------------------------------------------------------------------------------------------------| | true | Field Presets { #field-presets } | Tracker import { #webapi_tracker_import } | String | | 未定义 | JSON格式 | dryRun | enum:[id、code、name] | | id | GeoJSON 文件中使用的标识符所指向的组织单位属性 | attributeId | String | | 未定义 | JSON格式 | dryRun | boolean | | false | Field Presets { #field-presets } | flushMode | boolean | | false | Field Presets { #field-presets } | flushMode | POST /api/organisationUnits/geometry |

The post body is the GeoJSON file. Content type should be application/json or application/geo+json. The file may be .zip or .gzip compressed.

For example, a default file where id is used to refer to an organisation unit id has this structure:

{ 
  "type": "FeatureCollection",
  "features": [
    {
      "type": "Feature",
      "id": "O6uvpzGd5pu",
      "geometry": { ... }
    },
    ...
  ]
}

一个使用特征属性来引用组织单位代码的文件 将采用这种结构:

{ 
  "type": "FeatureCollection",
  "features": [
    {
      "type": "Feature",
      "properties": { "code": "OU1_CODE" },
      "geometry": { ... }
    },
    ...
  ]
}

几何体中的 坐标可以是成对的,也可以是三维的。 如果存在第三个维度,则会在导入时去除。

几何图形也可以是空,以有效清除或删除特定组织单位的几何图形。 删除。下一节将介绍一种特殊的批量删除 API。 将在下一节中介绍。 同步运行时,会直接返回导入报告。 HTTP 状态代码总是 OK,消息有效载荷中的 status表示是否所有记录都已成功导入。 表示是否成功导入了所有行。 报告中包含的导入计数统计信息可提供更多信息:

imported(导入的):成功更新了几何图形的组织单位数量,该组织单位在更新属性之前没有几何图形

updated: number of organisation units that were successfully updated with a geometry that did have value for the updated property already

  • ignored: number of organisation units that failed to update
  • deleted: number of organisation units that where successfully update with a empty geometry
  • When the import is run asynchronous the request returns immediately with status OK and job configuration response that contains a relative reference to the task endpoint that allows to track the status of the asynchronous import. For example:
  • /api/system/tasks/GEOJSON_IMPORT/{job-id}

同步执行时直接返回的摘要见

/api/system/taskSummaries/GEOJSON_IMPORT/{job-id}

一旦导入完成。

GeoJSON 批量数据删除{ #webapi_geojson_bulk_deletion }

要清除或取消设置所有组织单位的几何数据,请使用:

DELETE /api/organisationUnits/geometry

要清除或取消设置所有组织单位的特定 GEOJSON 属性的几何体数据,请使用 所有组织单位使用:

DELETE /api/organisationUnits/geometry?attributeId={attr-id}

Clearing is always synchronous and returns a similar report as the bulk import. It does not support any other parameters. No dry-run can be performed. Bulk clearing requires the F_PERFORM_MAINTENANCE authority.

GeoJSON 单一数据导入{ #webapi_geojson_single_import }

单次导入可以更新单个组织单元的几何图形。

POST /api/organisationUnits/{id}/geometry

例如,帖子正文只包含 GeoJSON geometry 值:

{
  "type": "Polygon",
  "coordinates": [...]
}

单次导入只支持 attributeId 和 dryRun 参数。 GeoJSON 单一数据删除{ #webapi_geojson_single_deletion } 要清除单个组织单位的 geometry GeoJSON 数据,请使用

DELETE /api/organisationUnits/{id}/geometry

同样,要清除单个组织的 GEOJSON 属性值 单位使用:

DELETE /api/organisationUnits/{id}/geometry?attributeId={attr-id}

Clearing is always synchronous returns a similar report as single import. The dry-run parameter is supported as well. The performing user requires authority to modify the target organisation unit.

架构图 { #webapi_schema }

可用于内省所有可用 DXF 2 对象的资源 可以在/api/schemas 上找到。对于特定资源,您可以拥有 查看/api/schemas/<type>。

要获取XML中所有可用的模式:

GET /api/schemas.xml

要获取JSON中所有可用的模式,请执行以下操作:

GET /api/schemas.json

要获取特定类的JSON模式:

GET /api/schemas/dataElement.json

图示 { #webapi_icons }

DHIS2 包含一系列图标,可用于为元数据提供可视化语境。 元数据的上下文。有两种不同的图标:

默认图标:预装在应用项目中,无法修改或删除。

自定义图标:可任意创建、更新和删除。 - 它们都可以通过图标资源访问。 - GET /api/icons

此端点返回有关可用默认图标和自定义图标的信息列表。 默认情况下,关键字、描述、关键字和 href 将包含在响应中。但可以使用字段参数来改变这种行为。

{
  key: "mosquito_outline",
  description: "Mosquito outline",
  keywords: [
    "malaria",
    "mosquito",
    "dengue"
  ],
  "created": "2024-02-12T09:50:11.794",
  "lastUpdated": "2024-02-12T09:50:11.794",
  href: "<dhis server>/api/icons/mosquito_outline/icon.svg"
}

也可以通过关键字过滤直接获取特定图标,在下面的例子中,关键字是 mosquito_outline。

GET /api/icons/mosquito_outline

自定义图标操作{ #webapi_icons_custom }

可通过某些请求参数获取自定义图标列表

GET /api/icons?type=CUSTOM

请求参数

类型

允许值 Potential duplicate status order Parameter name
jobType search keys Text
应检索的自定义图标键列表 createdStartDate Text
应检索自定义图标的关键字列表 createdStartDate Text
在图标键和关键字中搜索给定文本,并检索键或关键字中包含该文本的所有图标。 createdStartDate Date
创建日期的起点 createdEndDate Date
创建日期的终点 createdEndDate Date
最后更新日期的起点 createdEndDate Date
最后更新日期的终点 createdEndDate 请求参数

类型

允许值 Potential duplicate status order Parameter name
comma separated list of fields or presets to include 要返回的页码。如果缺少,默认为 1 paging Integer
默认 要返回的页码。如果缺少,默认为 1 paging Boolean
true|false 表示是否应忽略分页并返回所有行。默认为 true,即默认情况下所有请求都分页,除非 paging=false. 用于订购{ #request-parameters-for-ordering } 的请求参数 请求参数

类型

允许值 Potential duplicate status order Parameter name
extent of fields selected by * field selector createdStartDate 用于过滤响应的请求参数{ #request-parameter-to-filter-responses } The endpoints accept a fields parameter which controls which fields will be returned in the
JSON response. fields parameter accepts a comma separated list of field names. If nothing is specified, default fields will be used and those are

key,keywords,description,fileResourceUid,createdByUserUid,href

可通过提供图标密钥下载自定义图标资源:

GET /api/icons/{key}/icon

自定义图标可以创建、修改和删除。 要创建自定义图标,请使用下面的资源。

POST /api/icons

它需要一个包含图标关键字、描述、关键字列表和文件资源 uid 的有效载荷来链接数据。

{
    "key": "iconKey",
    "description": "description",
    "keywords": ["keyword 1","keyword 2"],
    "fileResourceUid": "ARsqBjfB2cf"
}

只能使用以下资源更新自定义图标。

PUT /api/icons

通过以下有效载荷,图标的描述和关键字将被更新。

{
    "key": "iconKey",
    "description": "new description",
    "keywords": ["new keyword 1", "new keyword 2"] 
}

请注意,也可以只更新其中一个。也就是说,如果我们想更新描述,同时保留关键字,只需提供图标键和描述 json 字段即可。反之亦然,更新关键字的同时保留原始描述。

只能使用以下资源删除自定义图标。

DELETE /api/icons/{icon_key}

渲染类型 { #webapi_render_type }

某些元数据类型具有名为 renderType 的属性。渲染类型 属性是 device 和 renderingType 之间的映射。应用 可以使用此信息作为有关如何呈现对象的提示 在特定设备上。例如,移动设备可能想要渲染 与台式计算机不同的数据元素。

当前有两种不同的renderingTypes可用:

值类型渲染

项目阶段部分渲染

  1. 还提供2种设备类型:

  2. 移动

桌面

  1. 下表列出了可用的元数据和呈现类型。 值类型呈现具有基于元数据的附加约束 配置,这将显示在第二个表中。

  2. 表格元数据和渲染类型概览

元数据类型

可用的渲染类型

项目阶段部分 * 列表(默认)
* 序列
* 矩阵
跟踪实体属性 * DEFAULT
* DROPDOWN
* VERTICAL_RADIOBUTTONS
* HORIZONTAL_RADIOBUTTONS
* VERTICAL_CHECKBOXES
* HORIZONTAL_CHECKBOXES
* SHARED_HEADER_RADIOBUTTONS
* ICONS_AS_BUTTONS
* SPINNER
* ICON
* TOGGLE
* VALUE
* SLIDER
* LINEAR_SCALE
* AUTOCOMPLETE
* QR_CODE
* BAR_CODE
* GS1_DATAMATRIX
描述 表:根据值类型允许的渲染类型

值类型

对象是一个选项集吗?

false | true TRUE_ONLY 不
单个变更建议可通过以下方式查看 Program notification template 不
JSON object for ADD proposal, JSON array for UPDATE proposal, nothing for REMOVE proposal Program notification template
Note that synthetic fields displayName and displayShortName are always
returning the translated value independent of the translate parameter. ```json
{
"name": "Case notification",
"notificationTrigger": "ENROLLMENT",
"subjectTemplate": "Case notification V{org_unit_name}",
"displaySubjectTemplate": "Case notification V{org_unit_name}",
"notifyUsersInHierarchyOnly": false,
"sendRepeatable": false,
"notificationRecipient": "ORGANISATION_UNIT_CONTACT",
"notifyParentOrganisationUnitOnly": false,
"displayMessageTemplate": "Case notification A{h5FuguPFF2j}",
"messageTemplate": "Case notification A{h5FuguPFF2j}",
"deliveryChannels": [
"EMAIL"
]
}
``` 不
验证基于此 regex ^[0-9+\(\)#\.\s\/ext-]{6,50}$.最大长度为 50。
例如+4733987937, (+47) 3398 7937, (47) 3398 7937.123
Program notification template 不
创建提案的日期时间 不 不
一般电子邮件格式 abc@email.com Program notification template
true or false Program notification template
数字 Program notification template
没有 Program notification template
没有 Program notification template
数值长度 = 1 并且是字母 Program notification template

值类型渲染也有一些额外的属性,可以 设置,通常在渲染某些特定类型时需要:

表:renderType 对象属性

财产

描述

指标组 Parameter name Potential duplicate status
枚举(参见元数据和渲染类型表中的列表) 分钟 仅用于值类型渲染。表示该字段可以具有的最小值。
整数 最大 Enrollments
最小-最大数据元素 { #webapi_min_max_data_elements } 步骤 Enrollments
整数 小数点 Enrollments
整数 renderingType 可以在创建或更新第一个表中列出的元数据时设置。项目阶段部分的渲染类型的示例负载如下所示: Enrollments

对于数据元素和跟踪的实体属性:

{
  "renderingType": {
    "type": "SLIDER",
    "min": 0,
    "max": 1000,
    "step": 50,
    "decimalPoints": 0
  }
}

对象样式 { #webapi_object_style }

大多数元数据都有一个属性名称“样式”。可以使用此属性 由客户以某种方式表示对象。属性 目前支持的样式如下:

表格样式属性

财产

描述

指标组 Parameter name Potential duplicate status
字符串 (#000000) 图标 图标,由图标名称表示。
串 目前,没有官方列表或对图标库的支持,所以
这目前由客户提供。下面的列表显示
所有支持样式的对象: 具有以下要求:

数据元素类别选项

  • 描述

  • 指示符

  • <indicator-id>

  • 对于组织单位维度,您可以指定组织

  • Validation rule

  • IndicatorGroup

  • 项目阶段

  • 项目阶段部分

  • 关系(跟踪器)

  • 跟踪实体属性

  • 追踪实体类型

  • 在创建或更新任何这些对象时,您可以包括 以下有效负载更改样式:

  • ```json { "style": { "color": "#ffffff", "icon": "my-beautiful-icon" } }

    类别选项{ #category-option } 
    
    合并类别选项{ #category_option_merge }
    
    ## 类别{ #category } 
    
    ### 合并类别{ #category_merge }
    
    类别合并端点允许您将多个类别(源)合并为一个目标类别。
    
    > **注**
    >
    > 类别只能在以下情况下合并
    > 
    > 1. 它们具有相同的类别选项<br> 
    > 源类别和目标类别不共享类别组合<br> 
    > 3. 源类别之间不共享类别组合<br> 
    >
    > 这些限制确保只有重复的类别才能被合并,并有助于保持系统的完整性。
    
    #### 请求{ #request } 
    
    执行类别合并所需的主要权限是 `F_CATEGORY_MERGE`。
    
    ####     /api/33/programs/orgUnits?programs={programIdA} 、{programIdB}
    
    通过 POST 请求合并类别:
    
    POST /api/categories/merge
    下表描述了 JSON 属性。
    
    表格合并有效载荷字段
    
    领域
    
    需要
    
    | The manual merge is suitable when there are resolvable conflicts or when not all the data needs to
    be moved during the merge. For example, if an attribute has different values in both tracked
    entities , the user can specify whether to keep the original value or move over the duplicate's
    value. Since the manual merge involves the user explicitly requesting to move data, there are some
    additional checks:         | 检索和删除项目通知模板 | ```json
    {
      "object": {
        "publicAccess": "rw------",
        "externalAccess": false,
        "user": {},
        "userAccesses": [],
        "userGroupAccesses": [
          {
            "id": "hj0nnsVsPLU",
            "access": "rw------"
          },
          {
            "id": "qMjBflJMOfB",
            "access": "r-------"
          }
        ]
      }
    }
    ```                                                                            |
    |---------------|----------|----------------------------------------------------------------------------------|
    | 要合并的类别选项(源类别选项)的标识符数组       | ```json
    {
        "name": "Case notification",
        "notificationTrigger": "ENROLLMENT",
        "subjectTemplate": "Case notification V{org_unit_name}",
        "displaySubjectTemplate": "Case notification V{org_unit_name}",
        "notifyUsersInHierarchyOnly": false,
        "sendRepeatable": false,
        "notificationRecipient": "ORGANISATION_UNIT_CONTACT",
        "notifyParentOrganisationUnitOnly": false,
        "displayMessageTemplate": "Case notification A{h5FuguPFF2j}",
        "messageTemplate": "Case notification A{h5FuguPFF2j}",
        "deliveryChannels": [
            "EMAIL"
        ]
    }
    ```      | 要合并的类别(源类别)的标识符数组          |
    | 将来源合并为指标(目标指标)的标识符        | ```json
    {
        "name": "Case notification",
        "notificationTrigger": "ENROLLMENT",
        "subjectTemplate": "Case notification V{org_unit_name}",
        "displaySubjectTemplate": "Case notification V{org_unit_name}",
        "notifyUsersInHierarchyOnly": false,
        "sendRepeatable": false,
        "notificationRecipient": "ORGANISATION_UNIT_CONTACT",
        "notifyParentOrganisationUnitOnly": false,
        "displayMessageTemplate": "Case notification A{h5FuguPFF2j}",
        "messageTemplate": "Case notification A{h5FuguPFF2j}",
        "deliveryChannels": [
            "EMAIL"
        ]
    }
    ```      | 将来源合并为类别(目标类别)的标识符       |
    | 是否在操作后删除源类别选项。默认为假。 | Program notification template       | 是否在操作后删除源类别。默认为假。   |
    
    合并操作将把源类别合并到目标类别中。可以指定一个或多个源类别。只能指定一个目标。
    
    合并操作会将所有源类别元数据关联转移到目标类别。
    以下元数据将被更新:
    
    | 采取的行动          | 指标组              | 类别选项组合                                                                                                                                                                              |
    |-------------------|-----------------------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
    | 删除来源    | 类别            | 类别选项组合                                                                                                                                                                            |
    | 删除来源     | 类别            | 成员                                                                                                                                                                |
    | 删除来源,添加目标 | 周期(pe)             | 选项组合                                                                                                                                                                |
    | Sharing of data store keys follows the same principle as for other metadata sharing (see
    [Sharing](developer-manual.md#webapi_sharing)).              | catDimensionConstraints | - 用户有一个或多个源和目标 -> 删除所有源约束<br/> - 用户有一个或多个源,无目标 -> 将一个源更新为目标,删除其他源约束 |
    
    
    #### 删除源
    
    错误代码
    
    描述
    
    | json(应用项目/ json) | Parameter name                                                                          |
    |------------|--------------------------------------------------------------------------------------|
    | E1531      | 必须指定至少一个来源类别                                       |
    | E1532      | 必须指定目标类别                                                    |
    | E1533      | 目标类别不能是源类别                                          |
    | 回复{ #response }       | 源/目标类别不存在: `{uid}`                                       |
    | E1535      | 源类别选项与目标类别选项不匹配                           |
    | E1536      | 源类别和目标类别不能共享一个类别组合                            |
    | E1537      | 源类别不能共享类别组合                                       |
    
    
    #### 成功响应示例如下
    ##### ```json
    {
        "httpStatus": "OK",
        "httpStatusCode": 200,
        "status": "OK",
        "response": {
            "mergeReport": {
                "mergeErrors": [],
                "mergeType": "IndicatorType",
                "sourcesDeleted": [
                    "vQ0dGV9EDrw"
                ],
                "message": "IndicatorType merge complete"
            }
        }
    }
    
    错误响应示例如下

``json { "httpStatus":"OK"、 "httpStatusCode":200, "status":"确定"、 "响应":{ "mergeReport":{ "mergeErrors":[], "mergeType":"类别"、 "sourcesDeleted":[ "FbLZS3ueWbQ"、"dPSWsKeAZNw" ], "消息":"类别合并完成" } } }

##### ```json
{
    "httpStatus": "Conflict",
    "httpStatusCode": 409,
    "status": "WARNING",
    "message": "One or more errors occurred, please see full details in merge report.",
    "response": {
        "mergeReport": {
            "mergeErrors": [
                {
                    "message": "At least one source DataElement must be specified",
                    "errorCode": "E1530",
                    "args": []
                },
                {
                    "message": "Target DataElement does not exist: `abcdefg1221`",
                    "errorCode": "E1533",
                    "args": [
                        "Target",
                        "abcdefg1221"
                    ]
                }
            ],
            "mergeType": "DataElement",
            "sourcesDeleted": [],
            "message": "DataElement merge has errors"
        }
    }
}
数据库约束样本错误响应:

`json { "httpStatus":"冲突"、 "httpStatusCode":409, "status":"WARNING"、 "消息":"发生了一个或多个错误,请查看合并报告中的全部详情。"、 "响应":{ "mergeReport":{ "mergeErrors":[ { "message":"必须指定至少一个源类别"、 "errorCode":"E1530", "args":[] }, { "message":"目标类别不存在:abcdefg1221`"、 "errorCode":"E1533", "args":[ "目标"、 "abcdefg1221" ] } ], "合并类型":"类别"、 "sourcesDeleted":[], "消息":"类别合并有错误" } } }

## 通过类别选项合并端点,可以将多个类别选项(源)合并为一个目标类别选项。

### 授权{ #authorisation } 

执行类别选项合并所需的主要权限是 `F_CATEGORY_OPTION_MERGE`。  
其他所需的权限涉及类别选项的一般共享和访问,即 `F_CATEGORY_OPTION_PUBLIC_ADD` 和 `F_CATEGORY_OPTION_DELETE`。

#### 请求{ #request } 

通过 POST 请求合并类别选项:

####     /api/33/programs/orgUnits?programs={programIdA} 、{programIdB}

JSON 格式的有效载荷如下所示:

```json
{
  "sources": [
    "FbLZS3ueWbQ",
    "dPSWsKeAZNw"
  ],
  "target": "rEq3Hkd3XXH",
  "deleteSources": true
}

下表描述了 JSON 属性。

表格合并有效载荷字段

领域

需要

| The manual merge is suitable when there are resolvable conflicts or when not all the data needs to be moved during the merge. For example, if an attribute has different values in both tracked entities , the user can specify whether to keep the original value or move over the duplicate's value. Since the manual merge involves the user explicitly requesting to move data, there are some additional checks: | 检索和删除项目通知模板 | json { "object": { "publicAccess": "rw------", "externalAccess": false, "user": {}, "userAccesses": [], "userGroupAccesses": [ { "id": "hj0nnsVsPLU", "access": "rw------" }, { "id": "qMjBflJMOfB", "access": "r-------" } ] } } | |-------------------|----------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------| | 要合并的类别选项(源类别选项)的标识符数组 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 是的 | | 将来源合并为指标(目标指标)的标识符 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 不 | | 是否在操作后删除源类别选项。默认为假。 | Program notification template | 合并操作会将所有源类别选项元数据关联转移到目标类别选项。 以下元数据将被更新: |

元数据

财产

采取的行动 指标组 类别选项组合
The status code will be 204 No Content if the data value was successfully saved or updated, or 409 Conflict if there was a validation error (e.g. more than one SHORT_NAME for the same locale). 类别选项组 成员
删除来源,添加目标 类别选项组合 成员
删除来源,添加目标 类别选项组 成员
删除来源,添加目标 组织单位 成员
DataElementCategory 类别选项组 成员

删除源

错误代码

描述

json(应用项目/ json) Parameter name
E1531 必须指定目标类别选项
E1532 目标类别选项不能是源类别选项
E1533 源/目标类别选项不存在: {uid}
回复{ #response } 成功{ #success }

成功响应示例如下

```json

{ "httpStatus": "OK", "httpStatusCode": 200, "status": "OK", "response": { "mergeReport": { "mergeErrors": [], "mergeType": "IndicatorType", "sourcesDeleted": [ "vQ0dGV9EDrw" ], "message": "IndicatorType merge complete" } } }

错误响应示例如下

错误响应示例如下

##### ```json
{
    "httpStatus": "Conflict",
    "httpStatusCode": 409,
    "status": "WARNING",
    "message": "One or more errors occurred, please see full details in merge report.",
    "response": {
        "mergeReport": {
            "mergeErrors": [
                {
                    "message": "At least one source DataElement must be specified",
                    "errorCode": "E1530",
                    "args": []
                },
                {
                    "message": "Target DataElement does not exist: `abcdefg1221`",
                    "errorCode": "E1533",
                    "args": [
                        "Target",
                        "abcdefg1221"
                    ]
                }
            ],
            "mergeType": "DataElement",
            "sourcesDeleted": [],
            "message": "DataElement merge has errors"
        }
    }
}
数据库约束样本错误响应:

进口验证{ #category_option_combo_import_validation }

CategoryOptionCombos are unique in that they are auto-generated by the system, most of the time (imports are allowed with specific expectations, mentioned below). They are generated based on their category model:

CategoryOption

Category (has category options) - CategoryCombo (has categories) - 将为 Category``CategoryOption 的每个组合创建一个 CategoryOptionCombo。 - 生成的 CategoryOptionCombo 示例{ #gen_category_option_combo_example }

有 1 个 CategoryCombo [CC1]

CC1 有 2 个类别 CC1=[C1, C2]

  • Each Category has 2 CategoryOptions C1=[CO1, CO2], C2=[CO3, CO4]
  • 从该类别模型生成的 CategoryOptionCombos 将产生 4 个 CategoryOptionCombos:
  • CO1=[CO1, CO3]
  • CO2=[CO1, CO4]
  • CO3=[CO2, CO3]
  • CO4=[CO2, CO4]
  • 在尝试导入 CategoryOptionCombos 时,理解这一点非常重要。导入 CategoryOptionCombos 时会执行验证,以确保提供的 CategoryOptionCombos 集与预期生成的 CategoryOptionCombos 集一致。这是为了确保不会有无效的状态/关系进入系统,从而防止出现各种问题(孤儿数据、数据库中未在 API 中公开的隐藏关系等)。
  • Note

    This validation is performed using the UIDs of the CategoryOptionCombos. No other idScheme is supported.

合并类别选项组合{ #category_option_combo_merge }

类别选项组合合并端点允许你将一些类别选项(源)合并到一个目标类别选项中。这可用于清理系统,例如删除重复内容。

> 注

只能合并重复的类别选项组合。有关这方面的更多信息,请参阅下面的验证部分。

授权{ #authorisation } 执行类别选项组合合并所需的主要权限是 F_CATEGORY_OPTION_COMBO_MERGE。

请求{ #request }

通过 POST 请求合并类别选项组合:

/api/33/programs/orgUnits?programs={programIdA} 、{programIdB}

JSON 格式的有效载荷如下所示:

{
  "sources": [
    "FbLZS3ueWbQ",
    "dPSWsKeAZNw"
  ],
  "target": "rEq3Hkd3XXH",
  "dataMergeStrategy": "DISCARD"
}

下表描述了 JSON 属性。

表格合并有效载荷字段

领域

需要

| The manual merge is suitable when there are resolvable conflicts or when not all the data needs to be moved during the merge. For example, if an attribute has different values in both tracked entities , the user can specify whether to keep the original value or move over the duplicate's value. Since the manual merge involves the user explicitly requesting to move data, there are some additional checks: | 检索和删除项目通知模板 | json { "object": { "publicAccess": "rw------", "externalAccess": false, "user": {}, "userAccesses": [], "userGroupAccesses": [ { "id": "hj0nnsVsPLU", "access": "rw------" }, { "id": "qMjBflJMOfB", "access": "r-------" } ] } } | |-------------------|----------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------| | 要合并的类别选项(源类别选项)的标识符数组 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 是的 | | 将来源合并为指标(目标指标)的标识符 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 是的 | | 如何处理数据值的合并。选项有 "DISCARD "或 "LAST_UPDATED"。DISCARD 将删除所有源数据值。LAST_UPDATED 会合并所有数据值,并在出现重复时使用最后更新的值。 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 合并操作将把所有源类别选项组合元数据关联转移到目标类别选项组合。 |

注

在合并过程中,所有源类别选项组合都会被删除。这是因为在处理完所有源引用后,会留下空的类别选项组合。系统认为这些选项组合无效。

更新以下元数据

元数据

财产

采取的行动 指标组 类别选项组合
删除来源 类别组合 类别选项组合
删除来源 数据元素操作数 类别选项组合
设定为目标 数据值审计 表情
设定为目标 表达 表情
以目标取代源 指示符 选项组合
对于组织单位维度,您可以指定组织 指示符 选项组合
对于组织单位维度,您可以指定组织 最小最大数据元素 选项组合
设定为目标 预测变量 表情
选项 SMSCode 表情
设定为目标 类别标识 表情
采取的行动 指标组 类别选项组合
根据合并策略(DISCARD / LAST_UPDATED)进行操作。DISCARD 将删除所有源数据值。LAST_UPDATED 将使用最后更新的数据值(如果存在多个数据值)。 数据值审计 属性选项组合
根据合并策略(DISCARD / LAST_UPDATED)进行操作。DISCARD 将删除所有源数据值。LAST_UPDATED 将使用最后更新的数据值(如果存在多个数据值)。 > 注
>
> 以下属性可能使用了外部系统的引用,因此被特意排除在合并之外。如果这些字段出现问题,可能需要更新。
>
> 指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo
>
> 项目指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo 属性选项组合
合并策略(DISCARD 或 LAST_UPDATED) > 注
>
> 以下属性可能使用了外部系统的引用,因此被特意排除在合并之外。如果这些字段出现问题,可能需要更新。
>
> 指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo
>
> 项目指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo 属性选项组合
DISCARD 或离开,取决于是否删除信息源 > 注
>
> 以下属性可能使用了外部系统的引用,因此被特意排除在合并之外。如果这些字段出现问题,可能需要更新。
>
> 指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo
>
> 项目指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo 属性选项组合
合并策略(DISCARD 或 LAST_UPDATED) > 注
>
> 以下属性可能使用了外部系统的引用,因此被特意排除在合并之外。如果这些字段出现问题,可能需要更新。
>
> 指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo
>
> 项目指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo 属性选项组合
DISCARD 或离开,取决于是否删除信息源 数据值审计 属性选项组合
DISCARD 或离开,取决于是否删除信息源 > 注
>
> 以下属性可能使用了外部系统的引用,因此被特意排除在合并之外。如果这些字段出现问题,可能需要更新。
>
> 指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo
>
> 项目指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo 属性选项组合
合并策略(DISCARD 或 LAST_UPDATED) > 注
>
> 以下属性可能使用了外部系统的引用,因此被特意排除在合并之外。如果这些字段出现问题,可能需要更新。
>
> 指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo
>
> 项目指标: aggregateExportCategoryOptionCombo & aggregateExportAttributeOptionCombo 属性选项组合

适用以下限制和错误代码。其中一个主要验证点是关于重复的 CategoryOptionCombos。 一个重复的 CategoryOptionCombo 就是一个满足条件的 CategoryOptionCombo:

删除源

具有相同的类别选项 - 有不同的 UID - 表:限制条件和错误代码 - 错误代码

描述

json(应用项目/ json) Parameter name
E1531 必须指定目标 CategoryOptionCombo
E1532 目标 CategoryOptionCombo 不能是源 CategoryOptionCombo
E1533 源/目标 CategoryOptionCombo 不存在: {uid}
回复{ #response } 必须指定 dataMergeStrategy 字段。值为 DISCARD 或 LAST_UPDATED 时
数据库约束{ #database-constraints } 类别选项组合必须重复(相同的类别组合、相同的类别选项、不同的 UID)才能合并
数据库约束{ #database-constraints } 有一些独特的制约因素可能会妨碍成功合并。这些限制由 DHIS2 设置,以维持一个逻辑域模型。
以下是撰写本文时已知的数据库唯一键约束列表。例如
只能有 1 个具有相同组织单位、数据元素和类别选项组合的最大最小数据元素。

表:数据库表唯一键约束

表格

唯一键约束

最小数据元素 orgunit, dataelement, categoryoptioncombo
计划阶段 项目阶段、数据元素

成功响应示例如下

```json

{ "httpStatus": "OK", "httpStatusCode": 200, "status": "OK", "response": { "mergeReport": { "mergeErrors": [], "mergeType": "IndicatorType", "sourcesDeleted": [ "vQ0dGV9EDrw" ], "message": "IndicatorType merge complete" } } }

错误响应示例如下

错误响应示例如下

##### ```json
{
    "httpStatus": "Conflict",
    "httpStatusCode": 409,
    "status": "WARNING",
    "message": "One or more errors occurred, please see full details in merge report.",
    "response": {
        "mergeReport": {
            "mergeErrors": [
                {
                    "message": "At least one source DataElement must be specified",
                    "errorCode": "E1530",
                    "args": []
                },
                {
                    "message": "Target DataElement does not exist: `abcdefg1221`",
                    "errorCode": "E1533",
                    "args": [
                        "Target",
                        "abcdefg1221"
                    ]
                }
            ],
            "mergeType": "DataElement",
            "sourcesDeleted": [],
            "message": "DataElement merge has errors"
        }
    }
}
数据库约束样本错误响应:
{
  "httpStatus": "Conflict",
  "httpStatusCode": 409,
  "status": "ERROR",
  "message": "ERROR: duplicate key value violates unique constraint \"minmaxdataelement_unique_key\"\n  Detail: Key (sourceid, dataelementid, categoryoptioncomboid)=(193236, 1148617, 167661) already exists."
}

数据元素 { #data-elements }

本节介绍指标和指标表达式。

类别组合{ #category-combo }

合并类别组合{ #category_combo_merge }

类别组合合并端点允许您将多个类别组合(源)合并为一个目标类别组合。

注

类别组合只有在以下情况下才能合并:

源类别组合和目标类别组合具有相同的类别
属于所涉类别组合的所有类别选项组合都是有效的(选项数量正确,选项成员有效)
所涉及的类别组合中不存在重复的类别选项组合

这些约束条件确保只有等同的类别组合才能被合并,并有助于维护系统的完整性。

警告

类别组合合并会产生重复的类别选项组合。在类别组合合并后,应立即合并这些组合,以保持系统的完整性。可以使用数据完整性检查 "category_option_combos_have_duplicates "发现重复。

请求{ #request }

执行类别组合合并所需的主要权限是 F_CATEGORY_COMBO_MERGE。

/api/33/programs/orgUnits?programs={programIdA} 、{programIdB}

通过 POST 请求合并类别组合:

POST /api/categoryCombos/merge

下表描述了 JSON 属性。

表格合并有效载荷字段

领域

需要

| The manual merge is suitable when there are resolvable conflicts or when not all the data needs to be moved during the merge. For example, if an attribute has different values in both tracked entities , the user can specify whether to keep the original value or move over the duplicate's value. Since the manual merge involves the user explicitly requesting to move data, there are some additional checks: | 检索和删除项目通知模板 | json { "object": { "publicAccess": "rw------", "externalAccess": false, "user": {}, "userAccesses": [], "userGroupAccesses": [ { "id": "hj0nnsVsPLU", "access": "rw------" }, { "id": "qMjBflJMOfB", "access": "r-------" } ] } } | |---------------|----------|------------------------------------------------------------------------------------| | 要合并的类别选项(源类别选项)的标识符数组 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 要合并的类别组合(源类别组合)的标识符数组 | | 将来源合并为指标(目标指标)的标识符 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 将来源合并为类别组合(目标类别组合)的标识符 | | 是否在操作后删除源类别选项。默认为假。 | Program notification template | 是否在操作后删除源类别组合。默认为假。 |

合并操作将把源类别组合合并到目标类别组合中。可以指定一个或多个源类别组合。只能指定一个目标。

合并操作会将所有源类别组合元数据关联转移到目标类别组合。 以下元数据将被更新:

采取的行动 指标组 类别选项组合
The status code will be 204 No Content if the data value was successfully saved or updated, or 409 Conflict if there was a validation error (e.g. more than one SHORT_NAME for the same locale). 类别组合 类别选项组合
删除来源,添加目标 类别组合 表情
Property name 类别组合 表情
设定为目标 类别组合 表情
DataElementGroup 类别组合 表情
IndicatorGroup 类别组合 表情
IndicatorGroup 注册类别组合 表情
以目标取代源 类别组合 表情
以目标取代源 属性类别组合 表情
数据审批工作流程 类别组合 表情

删除源

错误代码

描述

json(应用项目/ json) Parameter name
E1531 必须指定至少一个源 CategoryCombo
E1532 必须指定目标类别组合
E1533 目标分类组合不能是源分类组合
回复{ #response } 源/目标 CategoryCombo 不存在: {uid}
E1545 源和目标类别组合必须具有相同的类别:源 {uid} 具有 {categories}
E1546 CategoryOptionCombo 的 CategoryOptions 数量不正确。本应是 {n},但发现 {m} 的 COC: {uid}。
E1547 CategoryOptionCombo 具有对 CategoryCombo 类别无效的 CategoryOptions:{uid}
E1548 为 CategoryCombo {uid} 找到重复的 CategoryOptionCombo {uid}。请在尝试合并前修复此问题。

成功响应示例如下

```json

{ "httpStatus": "OK", "httpStatusCode": 200, "status": "OK", "response": { "mergeReport": { "mergeErrors": [], "mergeType": "IndicatorType", "sourcesDeleted": [ "vQ0dGV9EDrw" ], "message": "IndicatorType merge complete" } } }

错误响应示例如下

``json
{
    "httpStatus":"OK"、
    "httpStatusCode":200,
    "status":"确定"、
    "响应":{
        "mergeReport":{
            "mergeErrors":[],
            "mergeType":"CategoryCombo"、
            "sourcesDeleted":[
                "FbLZS3ueWbQ"、"dPSWsKeAZNw"
            ],
            "消息":"类别组合合并完成。合并后会出现重复的 CategoryOptionCombos。应立即合并,以保持系统完整性。可以使用数据完整性检查 "category_option_combos_have_duplicates "发现重复。
        }
    }
}
```json

{ "httpStatus": "Conflict", "httpStatusCode": 409, "status": "WARNING", "message": "One or more errors occurred, please see full details in merge report.", "response": { "mergeReport": { "mergeErrors": [ { "message": "At least one source DataElement must be specified", "errorCode": "E1530", "args": [] }, { "message": "Target DataElement does not exist: abcdefg1221", "errorCode": "E1533", "args": [ "Target", "abcdefg1221" ] } ], "mergeType": "DataElement", "sourcesDeleted": [], "message": "DataElement merge has errors" } } }

数据库约束样本错误响应:

``json
{
    "httpStatus":"冲突"、
    "httpStatusCode":409,
    "status":"WARNING"、
    "消息":"发生了一个或多个错误,请查看合并报告中的全部详情。"、
    "响应":{
        "mergeReport":{
            "mergeErrors":[
                {
                    "message":"必须指定至少一个源 CategoryCombo"、
                    "errorCode":"E1530",
                    "args":[]
                },
                {
                    "message":"目标 CategoryCombo 不存在:`abcdefg1221`"、
                    "errorCode":"E1533",
                    "args":[
                        "目标"、
                        "abcdefg1221"
                    ]
                }
            ],
            "合并类型":"CategoryCombo"、
            "sourcesDeleted":[],
            "信息":"类别组合合并有错误
        }
    }
}

> 注意事项

合并 DataElements 时应格外小心。特别注意 应特别注意合并涉及数据元素引用的数据值。 合并。在执行合并之前,应充分了解合并的潜在副作用。 合并。数据元素的合并具有深远的影响。以下信息 数据元素合并的内容。数据元素合并 涉及系统的所有主要部分(元数据、数据、跟踪器、分析和审计)。

如果源 DataElements 与大量数据/审计记录链接,系统性能可能会受到影响。

数据元素合并端点允许您将多个数据元素(源)合并为一个目标数据元素。

授权{ #authorisation }

执行数据元素合并所需的主要权限是 F_DATA_ELEMENT_MERGE。
所需的其他权限涉及数据元素的一般共享和访问,即 F_DATAELEMENT_PUBLIC_ADD 和 F_DATAELEMENT_DELETE。

请求{ #request }

通过 POST 请求合并数据元素:

/api/33/programs/orgUnits?programs={programIdA} 、{programIdB}

JSON 格式的有效载荷如下所示:

{
  "sources": [
    "jNb63DIHuwU",
    "WAjjFMDJKcx"
  ],
  "target": "V9rfpjwHbYg",
  "deleteSources": true,
  "dataMergeStrategy": "DISCARD"
}

下表描述了 JSON 属性。

表格合并有效载荷字段

领域

需要

| The manual merge is suitable when there are resolvable conflicts or when not all the data needs to be moved during the merge. For example, if an attribute has different values in both tracked entities , the user can specify whether to keep the original value or move over the duplicate's value. Since the manual merge involves the user explicitly requesting to move data, there are some additional checks: | 检索和删除项目通知模板 | json { "object": { "publicAccess": "rw------", "externalAccess": false, "user": {}, "userAccesses": [], "userGroupAccesses": [ { "id": "hj0nnsVsPLU", "access": "rw------" }, { "id": "qMjBflJMOfB", "access": "r-------" } ] } } | |-------------------|----------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------| | 要合并的类别选项(源类别选项)的标识符数组 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 是的 | | 将来源合并为指标(目标指标)的标识符 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 不 | | 是否在操作后删除源类别选项。默认为假。 | Program notification template | 是的 | | 如何处理数据值的合并。选项有 "DISCARD "或 "LAST_UPDATED"。DISCARD 将删除所有源数据值。LAST_UPDATED 会合并所有数据值,并在出现重复时使用最后更新的值。 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 合并操作将把所有源类别选项组合元数据关联转移到目标类别选项组合。 |

元数据

物业

采取的行动 指标组 类别选项组合
设定为目标 最小最大数据元素 数据元素
设定为目标 项目阶段数据元素 数据元素
删除来源,添加目标 最小最大数据元素 数据元素
项目 项目规则变量 数据元素
Points to note { #points-to-note } 最小最大数据元素 数据元素
fromToName, toFromName 最小最大数据元素 数据元素
设定为目标 最小最大数据元素 数据元素
设定为目标 最小最大数据元素 数据元素
设定为目标 最小最大数据元素 数据元素
设定为目标 最小最大数据元素 数据元素
选项 数据集元素 数据元素
设定为目标 最小最大数据元素 数据元素
设定为目标 最小最大数据元素 数据元素
删除来源,添加目标 数据元素组 成员
删除源指标,增加目标指标 数据元素组 成员
删除来源,添加目标 组织单位 成员
合并策略(DISCARD 或 LAST_UPDATED) 数据值 成员
对于组织单位维度,您可以指定组织 指示符 选项组合
对于组织单位维度,您可以指定组织 最小最大数据元素 选项组合
选项 预测变量 选项组合
选项 数据条目表格 选项组合
以目标取代源 计划指示器 选项组合
以目标取代源 指示符 选项组合
以目标取代源 数据值 选项组合
根据合并策略(DISCARD / LAST_UPDATED)进行操作。DISCARD 将删除所有源数据值。LAST_UPDATED 将使用最后更新的数据值(如果存在多个数据值)。 最小最大数据元素
采取的行动 指标组 类别选项组合
合并策略(DISCARD 或 LAST_UPDATED) 数据值 数据元素
根据合并策略(DISCARD / LAST_UPDATED)进行操作。DISCARD 将删除所有源数据值。LAST_UPDATED 将使用最后更新的数据值(如果存在多个数据值)。 最小最大数据元素 如果要删除信息源,则删除,否则不做任何操作。
数据值审计 适用以下限制条件和错误代码。
DISCARD 或离开,取决于是否删除信息源 适用以下限制条件和错误代码。

删除源

错误代码

描述

json(应用项目/ json) Parameter name
E1531 必须指定目标数据元素
E1532 目标数据元素不能是源指示符
E1533 源/目标数据元素不存在: {uid}
回复{ #response } All source ValueTypes must match target ValueType: ValueType. Other ValueTypes found: ValueType
E1551 所有源 DataElementDomain 必须与目标 DataElementDomain 匹配:DataElementDomain。找到的其他 DataElementDomain:DataElementDomain。
E1534 必须指定 dataMergeStrategy 字段。值为 DISCARD 或 LAST_UPDATED 时
数据库约束{ #database-constraints } 类别选项组合必须重复(相同的类别组合、相同的类别选项、不同的 UID)才能合并

表:数据库表唯一键约束

表格

唯一键约束

最小数据元素 orgunit, dataelement, categoryoptioncombo
计划阶段 项目阶段、数据元素
数据元素 数据集、数据元素
回复{ #response } 成功{ #success }

成功响应示例如下

```json

{ "httpStatus": "OK", "httpStatusCode": 200, "status": "OK", "response": { "mergeReport": { "mergeErrors": [], "mergeType": "IndicatorType", "sourcesDeleted": [ "vQ0dGV9EDrw" ], "message": "IndicatorType merge complete" } } }

错误响应示例如下

错误响应示例如下

##### ```json
{
    "httpStatus": "Conflict",
    "httpStatusCode": 409,
    "status": "WARNING",
    "message": "One or more errors occurred, please see full details in merge report.",
    "response": {
        "mergeReport": {
            "mergeErrors": [
                {
                    "message": "At least one source DataElement must be specified",
                    "errorCode": "E1530",
                    "args": []
                },
                {
                    "message": "Target DataElement does not exist: `abcdefg1221`",
                    "errorCode": "E1533",
                    "args": [
                        "Target",
                        "abcdefg1221"
                    ]
                }
            ],
            "mergeType": "DataElement",
            "sourcesDeleted": [],
            "message": "DataElement merge has errors"
        }
    }
}
数据库约束样本错误响应:
{
    "httpStatus": "Conflict",
    "httpStatusCode": 409,
    "status": "WARNING",
    "message": "One or more errors occurred, please see full details in merge report.",
    "response": {
        "mergeReport": {
            "mergeErrors": [
                {
                    "message": "All source ValueTypes must match target ValueType: `TEXT`. Other ValueTypes found: `NUMBER`",
                    "errorCode": "E1550",
                    "args": []
                }
            ],
            "mergeType": "DataElement",
            "sourcesDeleted": [],
            "message": "DataElement merge has errors"
        }
    }
}

数据库约束样本错误响应:

{
  "httpStatus": "Conflict",
  "httpStatusCode": 409,
  "status": "ERROR",
  "message": "ERROR: duplicate key value violates unique constraint \"minmaxdataelement_unique_key\"\n  Detail: Key (sourceid, dataelementid, categoryoptioncomboid)=(193236, 1148617, 167661) already exists."
}

数据元素 { #data-elements }

本节介绍指标和指标表达式。

综合指标

要检索指标,您可以向指标发出 GET 请求 像这样的资源:

/ api /指标

指标表示可以计算和呈现的表达式 因此。指标表达式分为分子和 分母。分子和分母是数学的 可以包含对数据元素、其他指标、常量和 组织单位组。变量将替换为数据 使用时的值,例如在报告中。允许的变量 表达式在下表中描述。

表:指标变量

变量

目的

#{<programstage-id>.<dataelement-id>} UID \ Parameter name
指集合数据元素和类别选项组合的组合。类别和属性选项组合 id 都是可选的,可以使用通配符"*"来表示任何值。 Syntax 类别 选项组
指一个综合数据元素和一个类别选项组,包含多个类别选项组合。 #{<data-element-id>} 汇总数据元素
指所有类别选项组合中的聚合数据元素的总值。 D{<program-id>.<data-element-id>} 项目数据元素
引用项目中跟踪器数据元素的值。 IN_GROUP-<indicatorgroup-id> 指所有类别选项组合中的聚合数据元素的总值。
指项目中被跟踪实体属性的值。 I{<program-indicator-id>} 计划指标
指项目指示器的值。 <dataelement-id> 引用项目中跟踪器数据元素的值。
指报告率指标。指标可以是REPORTING_RATE,REPORTING_RATE_ON_TIME,ACTUAL_REPORTS,ACTUAL_REPORTS_ON_TIME,EXPECTED_REPORTS。 C{<constant-id>} 指项目中被跟踪实体属性的值。
指恒定值。 N{<indicator-id>} 指示符
指现有指标。 对于组织单位维度,您可以指定组织 组织单位组
指组织单位组内组织单位的数量。 Category combination 项目

值

| 响应示例: | json { "object": { "publicAccess": "rw------", "externalAccess": false, "user": {}, "userAccesses": [], "userGroupAccesses": [ { "id": "hj0nnsVsPLU", "access": "rw------" }, { "id": "qMjBflJMOfB", "access": "r-------" } ] } } | Parameter name | |---|---|---| | 数据元素组中的所有汇总数据元素 | 数据元素组中的所有汇总数据元素 | deGroup:data-element-group-id | | 数据元素组中的所有汇总数据元素 | 类别-选项-组合-id | 类别-选项-组合-id | | 类别选项组合 | 类别选项组合 | co:category-option-id | | 类别选项组合 | 类别-选项-组合-id | coGroup:category-option-group-id | | 类别选项组合 | 类别-选项-组合-id | coGroup:co-group-id1&co-group-id2... | | 类别选项组合 | 语法看起来像 这: | #{.} + C{} + OUG{} |

一个相应的例子看起来像 这:

请注意,对于数据元素变量,类别选项组合 标识符可以省略。该变量将代表总数 对于数据元素,例如在所有类别选项组合中。例子:

数据元素操作数可以包括任何类别选项组合和 属性选项组合,并使用通配符表示任何 价值:

#{P3jJH5Tu5VC.S34ULMcHMca} + #{P3jJH5Tu5VC.*.j8vBiBqGf6O} + #{P3jJH5Tu5VC.S34ULMcHMca.*}

使用数据元素组的示例

#{deGroup:oDkJh5Ddh7d}+ #{deGroup:GBHN1a1Jddh.j8vBiBqGf6O}

使用类别选项、数据元素组和类别选项组的示例:

#{P3jJH5Tu5VC.co:FbLZS3ueWbQ}+ #{deGroup:GBHN1a1Jddh.coGroup:OK2Nr4wdfrZ.j8vBiBqGf6O}

使用多个类别选项组的示例:

#{P3jJH5Tu5VC.coGroup:OK2Nr4wdfrZ&j3C417uW6J7&ddAo6zmIHOk}

使用项目数据元素和项目属性的示例:

(D {eBAyeGv0exc.vV9UWAZohSf} * A {IpHINAT79UW.cejWyOfXge6})/ D {eBAyeGv0exc.GieVkTxp4HH}

结合计划指标和综合指标的示例:

I {EMOt6Fwhs1n} * 1000 /#{WUg3MYWQ7pt}

以报告率为例:

R {BfMAe6Itzgt.REPORTING_RATE} *#{P3jJH5Tu5VC.S34ULMcHMca}

另一个使用实际数据集报告和预期报告的报告率示例:

R {BfMAe6Itzgt.ACTUAL_REPORTS} / R {BfMAe6Itzgt.EXPECTED_REPORTS}

使用现有指标的示例

N {Rigf2d2Zbjp} *#{P3jJH5Tu5VC.S34ULMcHMca}

表达式可以是任何类型的有效数学表达式,作为 例子:

(2 *#{P3jJH5Tu5VC.S34ULMcHMca})/(#{FQ2o8UBlcrS.S34ULMcHMca}-200)* 25

计划指标 { #webapi_program_indicators }

要检索项目指标,您可以向项目发出 GET 请求 像这样的指标资源:

/ api / programIndicators

项目指示器可以包含在项目中收集的信息。 指标有一个表达式,可以包含对数据的引用 元素、属性、常量和项目变量。变量 下表中描述了允许在表达式中使用。

表:计划指标变量

变量

描述

#{<programstage-id>.<dataelement-id>} Parameter name
A{<attribute-id>} 指跟踪的实体属性。
V{<variable-id>} 指项目变量。
C{<constant-id>} 指一个常数。
指恒定值。 #{.} + #{} + V{} + C{}

一个相应的例子看起来像 这:

#{A03MvHHogjR.a3kGcGDCuk6} + A{OvY4VVhSDeJ} + V{incident_date} + C{bCqvfPR02Im}

表达方式 { #webapi_expressions }

表达式是数学公式,可以包含对 数据元素、常量和组织单元组。验证和 获取表达式的文本描述,您可以发出 GET 请求 到表达式资源:

/ api / expressions / description?expression =

响应遵循标准的 JSON Web 消息格式。 状态 属性表示验证的结果,如果 成功和“错误”如果失败。 message 属性将为“有效” 如果成功并提供原因的文字描述 如果不是,则验证失败。 *描述*提供了文字说明 表达式的描述。

{
  "httpStatus": "OK",
  "httpStatusCode": 200,
  "status": "OK",
  "message": "Valid",
  "description": "Acute Flaccid Paralysis"
}

合并指标{ #webapi_indicator_merge }

通过指标合并端点,可以将多个指标(源)合并为一个目标指标。

授权{ #authorisation }

执行指标合并需要使用权限 F_INDICATOR_MERGE。

请求{ #request }

通过 POST 请求合并指标:

/api/33/programs/orgUnits?programs={programIdA} 、{programIdB}

JSON 格式的有效载荷如下所示:

{
  "sources": [
    "jNb63DIHuwU",
    "WAjjFMDJKcx"
  ],
  "target": "V9rfpjwHbYg",
  "deleteSources": true
}

下表描述了 JSON 属性。

表格合并有效载荷字段

领域

需要

| The manual merge is suitable when there are resolvable conflicts or when not all the data needs to be moved during the merge. For example, if an attribute has different values in both tracked entities , the user can specify whether to keep the original value or move over the duplicate's value. Since the manual merge involves the user explicitly requesting to move data, there are some additional checks: | 检索和删除项目通知模板 | json { "object": { "publicAccess": "rw------", "externalAccess": false, "user": {}, "userAccesses": [], "userGroupAccesses": [ { "id": "hj0nnsVsPLU", "access": "rw------" }, { "id": "qMjBflJMOfB", "access": "r-------" } ] } } | |---------------|----------|-------------------------------------------------------------------------------| | 要合并的类别选项(源类别选项)的标识符数组 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 是的 | | 将来源合并为指标(目标指标)的标识符 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 不 | | 是否在操作后删除源类别选项。默认为假。 | Program notification template | 合并操作将把所有源指标元数据关联转移到目标指标。 以下元数据将被更新: |

元数据

物业

采取的行动 指标组 类别选项组合
删除源指标,增加目标指标 组织单位 基础设施指标(指标组)
DataElementGroup 组态 基础设施指标(指标组)
任何有来源的链接数据项都将与目标数据项链接 部门 指标
删除源指标,增加目标指标 组态 基础设施指标(指标组)
The reference is present and not null in the payload. 指示符 基础设施指标(指标组)
对于组织单位维度,您可以指定组织 数据条目表格 htmlCode
以目标取代源 计划指示器 htmlCode
将任何源引用替换为目标引用作为排序维度 验证{ #validation } 适用以下限制条件和错误代码。

删除源

错误代码

描述

json(应用项目/ json) Parameter name
E1531 必须指定目标指标
E1532 目标指标不能是源指标
E1533 源/目标指标不存在: {uid}
回复{ #response } 成功{ #success }

成功响应示例如下

```json

{ "httpStatus": "OK", "httpStatusCode": 200, "status": "OK", "response": { "mergeReport": { "mergeErrors": [], "mergeType": "IndicatorType", "sourcesDeleted": [ "vQ0dGV9EDrw" ], "message": "IndicatorType merge complete" } } }

错误响应示例如下

```json
{
    "httpStatus": "Conflict",
    "httpStatusCode": 409,
    "status": "WARNING",
    "message": "One or more errors occurred, please see full details in merge report.",
    "response": {
        "mergeReport": {
            "mergeErrors": [
                {
                    "message": "At least one source Indicator must be specified",
                    "errorCode": "E1530",
                    "args": []
                },
                {
                    "message": "Target Indicator does not exist: `abcdefg1221`",
                    "errorCode": "E1533",
                    "args": [
                        "Target",
                        "abcdefg1221"
                    ]
                }
            ],
            "mergeType": "Indicator",
            "sourcesDeleted": [],
            "message": "Indicator merge has errors"
        }
    }
}

数据库约束样本错误响应:

合并指标类型 { #webapi_indicator_type_merge}

通过指标类型合并端点,可以将多个指标类型合并为一个目标指标类型。

授权{ #authorisation }

执行指示符类型合并需要使用权限 F_INDICATOR_TYPE_MERGE。

请求{ #request }

通过 POST 请求合并指标类型:

/api/33/programs/orgUnits?programs={programIdA} 、{programIdB}

JSON 格式的有效载荷如下所示:

{
  "sources": [
    "jNb63DIHuwU",
    "WAjjFMDJKcx"
  ],
  "target": "V9rfpjwHbYg",
  "deleteSources": true
}

下表描述了 JSON 属性。

表格合并有效载荷字段

领域

需要

| The manual merge is suitable when there are resolvable conflicts or when not all the data needs to be moved during the merge. For example, if an attribute has different values in both tracked entities , the user can specify whether to keep the original value or move over the duplicate's value. Since the manual merge involves the user explicitly requesting to move data, there are some additional checks: | 检索和删除项目通知模板 | json { "object": { "publicAccess": "rw------", "externalAccess": false, "user": {}, "userAccesses": [], "userGroupAccesses": [ { "id": "hj0nnsVsPLU", "access": "rw------" }, { "id": "qMjBflJMOfB", "access": "r-------" } ] } } | |---------------|----------|-----------------------------------------------------------------------------------------| | 要合并的类别选项(源类别选项)的标识符数组 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 是的 | | 将来源合并为指标(目标指标)的标识符 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 不 | | 是否在操作后删除源类别选项。默认为假。 | Program notification template | 合并操作将把源指标类型的所有指标元数据关联转移到目标指标类型。 |

验证{ #validation }

适用以下限制条件和错误代码。

删除源

错误代码

描述

json(应用项目/ json) Parameter name
E1531 必须指定目标指标类型
E1532 目标指标类型不能是源指标类型
E1533 源/目标指标类型不存在: {uid}
回复{ #response } 成功{ #success }

成功响应示例如下

```json

{ "httpStatus": "OK", "httpStatusCode": 200, "status": "OK", "response": { "mergeReport": { "mergeErrors": [], "mergeType": "IndicatorType", "sourcesDeleted": [ "vQ0dGV9EDrw" ], "message": "IndicatorType merge complete" } } }

错误响应示例如下

```json
{
    "httpStatus": "Conflict",
    "httpStatusCode": 409,
    "status": "WARNING",
    "message": "One or more errors occurred, please see full details in merge report.",
    "response": {
        "mergeReport": {
            "mergeErrors": [
                {
                    "message": "At least one source IndicatorType must be specified",
                    "errorCode": "E1530",
                    "args": []
                },
                {
                    "message": "Target IndicatorType does not exist: `abcdefg1221`",
                    "errorCode": "E1533",
                    "args": [
                        "Target",
                        "abcdefg1221"
                    ]
                }
            ],
            "mergeType": "IndicatorType",
            "sourcesDeleted": [],
            "message": "IndicatorType merge has errors"
        }
    }
}

数据库约束样本错误响应:

organisationUnits 资源遵循标准约定,如 DHIS2 中的其他元数据资源。该资源支持一些 附加查询参数。

获取组织单位列表

要获取组织单位的列表,可以使用以下资源。

/ api / 33 / organisationUnits

表:组织单位查询参数

查询参数

选项

eventCreatedPeriod 用户设置 { #webapi_user_settings } Parameter name
真 假 仅 userDataView
假 假 数据视图组织单位只与当前用户相关。
userDataViewFallback 假 真
仅与当前用户相关联的数据视图组织单位,可退回到数据采集组织单位。 不区分大小写的字符串结尾匹配 字符串
查询名称、代码和 ID 属性。 查询参数 整数
层次结构中指定级别的组织单位。 查询参数 整数
在给定的最大级别或更高级别上的组织单位。 假 假
真 假 withinUserSearchHierarchy
假 不区分大小写的字符串结尾匹配 将搜索和检索限制在当前用户搜索范围内的组织单位。注意:"in withinUserHierarchy"(如果为 true)优先级更高。
会员收藏 串 对于显示集合内成员的计数,指的是与组织单位相关联的集合名称。

成员对象

用户标识

用于显示集合中成员的计数,指集合对象成员的标识符。

获取带有子层次结构的组织单位{ #webapi_organisation_units_with_sub_hierarchy }

eventCreatedPeriod 用户设置 { #webapi_user_settings } Parameter name
查询参数 假 描述
包括儿童 假 真
包括指定组织单位的直属子单位,即子层次结构中下一级的直属单位。 假 假
查询名称、代码和 ID 属性。 查询参数 包括祖先

假

真

包括指定组织单位的所有家长。

夷为平地

整数

包括子层次结构中指定级别的指定组织单位的子机构。这是相对于组织单位而言的,从 1 开始为紧接组织单位之下的层级。

按类别获取组织单位选项

专门用于检索类别选项与组织单位之间关联的端点。该端点是检索项目组织单位关联的首选方式。

/api/33/categoryOptions/orgUnits?categoryOptions={categoryOptionIdA} 、{categoryOptionIdB}

夷为平地

{
  "<categoryOptionIdA>": [
    "<orgUnitUid>",
    "<orgUnitUid>"
  ],
  "<categoryOptionIdB>": [
    "<orgUnitUid>",
    "<orgUnitUid>"
  ],
  "<categoryOptionIdC>": []
}

所有组织单位都能访问的类别选项会以组织单位的空数组([])返回。

按项目获取组织单位{ #webapi_organisation_units_by_programs }

专用端点,用于检索项目与组织单位之间的关联。该端点是检索项目与组织单位关联的首选方式。

/api/33/programs/orgUnits?programs={programIdA} 、{programIdB}

答复的格式如下

{
  "<programIdA>": [
    "<orgUnitUid>",
    "<orgUnitUid>"
  ],
  "<programIdB>": [
    "<orgUnitUid>",
    "<orgUnitUid>"
  ],
  "<programIdC>": []
}

下表描述了 JSON 属性。

分体式组织单位{ #webapi_organisation_unit_split }

领域

请求{ #request }

| The manual merge is suitable when there are resolvable conflicts or when not all the data needs to be moved during the merge. For example, if an attribute has different values in both tracked entities , the user can specify whether to keep the original value or move over the duplicate's value. Since the manual merge involves the user explicitly requesting to move data, there are some additional checks: | 检索和删除项目通知模板 | json { "object": { "publicAccess": "rw------", "externalAccess": false, "user": {}, "userAccesses": [], "userGroupAccesses": [ { "id": "hj0nnsVsPLU", "access": "rw------" }, { "id": "qMjBflJMOfB", "access": "r-------" } ] } } | | ------------- | -------- |------ | | json { "source": "rspjJHg4WY1", "targets": [ "HT0w9YLMLyn", "rEpnzuNpRKM" ], "primaryTarget": "HT0w9YLMLyn", "deleteSource": true } | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 表格分割有效载荷字段 | | 领域 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 值 | | 消息来源 | Program notification template | 要拆分的组织单位(源组织单位)的标识符。 | | 目标 | Program notification template | 要将源代码分割成的组织单位(目标组织单位)的标识符数组。 |

主要目标

不

要将与源相关的汇总数据、事件和跟踪实体转移到的组织单位的标识符。如果未指定,将使用第一个目标。

删除源

错误代码

描述

json(应用项目/ json) Parameter name
该操作将把源组织单位的所有数据记录转移到指定为主要目标的组织单位,如果没有指定,则转移到第一个指定的目标组织单位。这包括汇总数据值、数据批准记录、事件、跟踪实体等。 验证{ #validation }
适用以下限制条件和错误代码。 表:限制条件和错误代码
错误代码 描述
E1510 必须指定来源网络单位
E1511 必须指定至少两个目标组织单位
E1512 源组织单位不能是目标组织单位

E1513

必须指定主要目标

请求{ #request }

主要目标必须是目标组织单位

/api/33/programs/orgUnits?programs={programIdA} 、{programIdB}

目标组织单位不存在

合并组织单位 { #webapi_organisation_unit_merge}

下表描述了 JSON 属性。

授权{ #authorisation }

领域

需要

| The manual merge is suitable when there are resolvable conflicts or when not all the data needs to be moved during the merge. For example, if an attribute has different values in both tracked entities , the user can specify whether to keep the original value or move over the duplicate's value. Since the manual merge involves the user explicitly requesting to move data, there are some additional checks: | 检索和删除项目通知模板 | json { "object": { "publicAccess": "rw------", "externalAccess": false, "user": {}, "userAccesses": [], "userGroupAccesses": [ { "id": "hj0nnsVsPLU", "access": "rw------" }, { "id": "qMjBflJMOfB", "access": "r-------" } ] } } | | ------------------------- | -------- | ----- | | 要合并的类别选项(源类别选项)的标识符数组 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 表格合并有效载荷字段 | | 将来源合并为指标(目标指标)的标识符 | json { "name": "Case notification", "notificationTrigger": "ENROLLMENT", "subjectTemplate": "Case notification V{org_unit_name}", "displaySubjectTemplate": "Case notification V{org_unit_name}", "notifyUsersInHierarchyOnly": false, "sendRepeatable": false, "notificationRecipient": "ORGANISATION_UNIT_CONTACT", "notifyParentOrganisationUnitOnly": false, "displayMessageTemplate": "Case notification A{h5FuguPFF2j}", "messageTemplate": "Case notification A{h5FuguPFF2j}", "deliveryChannels": [ "EMAIL" ] } | 值 | | 资源 | Program notification template | 要合并的组织单位(源组织单位)的标识符数组。 | | 目标 | Program notification template | 要将数据源合并到的组织单位(目标组织单位)的标识符。 | | 是否在操作后删除源类别选项。默认为假。 | Program notification template | Strategy for merging data values. Options: LAST_UPDATED (default), DISCARD. |

数据审批合并策略

不

Strategy for merging data approval records. Options: LAST_UPDATED (default), DISCARD.

删除源

错误代码

描述

json(应用项目/ json) Parameter name
指定的数据值合并策略定义了如何处理数据值。对于LAST_UPDATED策略,所有源组织单位的数据值都将转移到目标组织单位,并且在相同参数存在数据值的情况下,将使用最后更新或创建的数据值。这样做是为了避免数据重复。对于DISCARD策略,数据值不会转移到目标组织单位,而是简单地删除。指定的数据审批合并策略定义了数据审批记录的处理方式,并遵循与数据值相同的逻辑。 验证{ #validation }
适用以下限制条件和错误代码。 表:限制条件和错误代码
错误代码 描述
E1500 必须指定至少两个来源组织单位

E1501

必须指定目标组织单位

E1502

目标组织单位不能是源组织单位

E1503

源机构单位不存在

数据集 { #webapi_data_sets }

dataSets 资源遵循标准约定作为其他

DHIS2 中的元数据资源。此资源支持一些额外的 查询参数。

/ api / 33 / dataSets

要检索数据集的版本,您可以发出GET请求:

GET /api/33/dataSets/<uid>/version

要提高(增加一个)数据集的版本,您可以发出 POST 要求:

POST / api / 33 / dataSets / <uid> / version

数据集通知模板{ #webapi_dataset_notifications }

*数据集通知模板*资源遵循标准 DHIS2 中其他元数据资源的约定。

GET /api/33/dataSetNotficationTemplates

要检索数据集通知模板,您可以发出GET请求:

GET /api/33/dataSetNotficationTemplates/<uid>

要添加数据集通知模板,您可以发出POST请求: - POST / api / 33 / dataSetNotficationTemplates - 要删除数据集通知模板,您可以发出DELETE请求:

删除/ api / 33 / dataSetNotficationTemplates /

JSON有效负载示例如下:

{
  "name": "dataSetNotificationTemplate1",
  "dataSetNotificationTrigger": "DATA_SET_COMPLETION",
  "relativeScheduledDays": 0,
  "notificationRecipient": "ORGANISATION_UNIT_CONTACT",
  "dataSets": [{
    "id": "eZDhcZi6FLP"
  }],
  "deliveryChannels": ["SMS","EMAIL"],
  "subjectTemplate": "V{data_set_name}",
  "messageTemplate": "V{data_set_name}V{registration_period}",
  "sendStrategy": "SINGLE_NOTIFICATION"
}

notificationRecipient can be one of:

USER_GROUP for internal messages

ORGANISATION_UNIT_CONTACT for external messages

填充的组织单位级别 { #webapi_filled_organisation_unit_levels }

fillOrganisationUnitLevels 资源提供了一个有序的列表 组织单元级别,其中生成的级别被注入到 列表以填充不存在持久级别的位置。

GET /api/33/filledOrganisationUnitLevels

要设置组织单位级别,您可以发出一个 POST 请求,其中包含一个

内容类型为 application/json 的 POST 请求:

{
  "organisationUnitLevels": [{
    "name": "National",
    "level": 1,
    "offlineLevels": 3
  }, {
    "name": "District",
    "level": 2
  }, {
    "name": "Chiefdom",
    "level": 3
  }, {
    "name": "Facility",
    "level": 4
  }]
}

预测变量 { #webapi_predictors }

预测器允许您根据表达式生成数据值。 这可以用于例如生成目标、阈值、 或估计值。

要检索预测器,您可以向预测器发出 GET 请求 像这样的资源:

/ api / predictors

创建预测变量

您可以使用对预测器的 POST 请求创建预测器 资源:

POST / api / predictors
#{<programstage-id>.<dataelement-id>} UID \ Parameter name
预测表达式 { #webapi_predictor_expressions } D{<program-id>.<data-element-id>} 项目数据元素
变量 Syntax 描述
#{} IN_GROUP-<indicatorgroup-id> 指所有类别选项组合中的聚合数据元素的总值。
#{. I{<program-indicator-id>} 计划指标
D{.} <dataelement-id> 引用项目中跟踪器数据元素的值。
A{.} C{<constant-id>} 指项目中被跟踪实体属性的值。
I{} N{<indicator-id>} 指示符
R{.} Category combination 项目
C{} 不变 指恒定值。

OUG{}

组织单位组

指组织单位组内组织单位的数量。

[天]

天数

当前期间的天数。

生成预测值 { #webapi_generating_predicted_values }

要运行所有预测器(生成预测值),您可以进行 POST 请求运行资源:

POST / api / predictors / run

要运行单个预测器,您可以向运行发出 POST 请求 预测器的资源:

POST / api / predictors / AG10KUJCrRk / run

计划{ #webapi_programs }

要检索项目,可以像这样向项目资源发出 GET 请求:

/api/programs

[...]
